SystemOrganization addCategory: #Seamless!
SystemOrganization addCategory: 'Seamless-Authentication-Manager'!
SystemOrganization addCategory: 'Seamless-Benchmarking'!
SystemOrganization addCategory: 'Seamless-Connection'!
SystemOrganization addCategory: 'Seamless-Data-Transporter'!
SystemOrganization addCategory: 'Seamless-Deamon'!
SystemOrganization addCategory: 'Seamless-Distribution-Control'!
SystemOrganization addCategory: 'Seamless-Distribution-Policy'!
SystemOrganization addCategory: 'Seamless-Distribution-Table'!
SystemOrganization addCategory: 'Seamless-Examples'!
SystemOrganization addCategory: 'Seamless-Garbage-Collector'!
SystemOrganization addCategory: 'Seamless-Logging'!
SystemOrganization addCategory: 'Seamless-Object-Transporter'!
SystemOrganization addCategory: 'Seamless-Process-Manager'!
SystemOrganization addCategory: 'Seamless-Protocol-Packets'!
SystemOrganization addCategory: 'Seamless-Proxies'!
SystemOrganization addCategory: 'Seamless-Security-Policy'!
SystemOrganization addCategory: 'Seamless-Session'!
SystemOrganization addCategory: 'Seamless-Transcoder'!

Trait named: #TSeamlessRemoteProxy
	uses: {}
	category: 'Seamless-Proxies'!

!TSeamlessRemoteProxy classSide methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 11:12'!
defaultHandlerClass

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/23/2012 21:58'!
inspectorClass

	^ Smalltalk tools inspector! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/21/2012 15:57'!
mustBeBoolean

	^ false! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:33'!
xxx___handler

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:33'!
xxx___handler: aHandler

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 11:35'!
xxx___isProxy

	^ true! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 20:43'!
xxx___messageIntercepted: aMessage

		^ self xxx___handler messageInterceptedInProcess: (Processor activeProcess) by: self withSelector: aMessage selector andArguments: aMessage arguments. ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 18:26'!
xxx___onMessageInterceptEvaluate: aBlock

	self xxx___handler onMessageInterceptEvaluate: aBlock.! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 11:36'!
xxx___remoteObjectId

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 11:36'!
xxx___remoteObjectId: aRemoteObjectId

	self subclassResponsibility ! !

Trait named: #TSeamlessRemoteProxyHandler
	uses: {}
	category: 'Seamless-Proxies'!

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:35'!
messageInterceptCallback

	self subclassResponsibility ! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:34'!
messageInterceptCallback: aBlock

	self subclassResponsibility ! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 20:43'!
messageInterceptedInProcess: aProcess by: aProxy withSelector: aSelector andArguments: args 

	self messageInterceptCallback ifNotNil: [
		^ self messageInterceptCallback value: aProcess value: aProxy value: aSelector value: args
	]! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:35'!
onMessageInterceptEvaluate: aBlock

	self messageInterceptCallback: aBlock! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 15:45'!
session

	self subclassResponsibility ! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 15:45'!
session: aSeamlessSession 

	self subclassResponsibility ! !

Error subclass: #SeamlessSecurityError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Security-Policy'!

!String methodsFor: '*Seamless' stamp: 'NickPapoulias 8/20/2012 12:43'!
asRemoteEnvironment

	^ SeamlessDeamonManager default addressAsRemoteEnvironment: self! !

!String methodsFor: '*Seamless' stamp: 'NickPapoulias 8/20/2012 12:45'!
globalAt: aSymbol

	^ self asRemoteEnvironment at: aSymbol! !

OrderedCollection subclass: #PingPong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!PingPong methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/23/2012 19:30'!
decrement: aNumber using: aPingPongInstance
	
	aNumber = 0 ifFalse: [
	
		aPingPongInstance 
			decrement: aNumber - 1 
			using: self.
		
	].

	Transcript show: aNumber; cr.! !

!PingPong methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/23/2012 19:30'!
decrement: aNumber using: aPingPongInstance and: aBlock
	
	aNumber = 0 ifFalse: [
	
		aPingPongInstance 
			decrement: (aBlock value: aNumber) 
			using: self 
			and: [:x | aBlock value: x ].
		
	].

	Transcript show: aNumber; cr.! !

OrderedCollection subclass: #SeamlessOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

Array variableSubclass: #SeamlessArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

Exception subclass: #SeamlessSecurityException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Security-Policy'!

TestCase subclass: #SeamlessDeamonTest
	instanceVariableNames: 'localDeamon remoteDeamon localTestClassInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 18:29'!
connectLocalToRemoteDeamon

	^ localDeamon connectOn: '127.0.0.1:8081'! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2012 12:42'!
setUp

	localDeamon := SeamlessDeamon newDefaultWithGlobalAccess startOn: 8080.
	remoteDeamon := SeamlessDeamon newDefaultWithGlobalAccess startOn: 8081.! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 22:24'!
tearDown

	localDeamon stop.
	
	remoteDeamon stop.! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 12:49'!
testConnectOn

	|entryPoint|
	
	entryPoint := self connectLocalToRemoteDeamon.
	
	self assert: (entryPoint xxx___isProxy).! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 20:49'!
testInsanlyMutualRecursion

	|entryPoint remoteTestClassInstance|

	entryPoint := self connectLocalToRemoteDeamon.
	
	remoteTestClassInstance := (entryPoint at: #MockForMutualRecursion) new.
	localTestClassInstance := MockForMutualRecursion new.

	self assert: (localTestClassInstance decrement: 10 with: remoteTestClassInstance using: [:value | value - 1]) = 0.! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 20:59'!
testInsanlyMutualRecursionPassingLargeByValue

	|entryPoint remoteTestClassInstance|

	entryPoint := self connectLocalToRemoteDeamon.
	
	remoteTestClassInstance := (entryPoint at: #MockForMutualRecursion) new.
	localTestClassInstance := MockForMutualRecursion new.

	self assert: (localTestClassInstance decrement: 10 with: remoteTestClassInstance using: [:value | value - 1] passing: (1 to: 10000000) asOrderedCollection asString) = 0.! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 14:51'!
testLargeByValue

	|entryPoint remoteTranscript|
	
	entryPoint := self connectLocalToRemoteDeamon.
	"send the class message"
	remoteTranscript := entryPoint at: #Transcript.

	(1 to: 10) do: [:i | remoteTranscript show: (1 to: 10000000) asOrderedCollection asString].! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 21:09'!
testMessageSend

	|entryPoint returnProxy|
	
	entryPoint := self connectLocalToRemoteDeamon.
	"send the class message"
	returnProxy := entryPoint at: #Object.
"	Transcript show: 'entryPoint: '; show: entryPoint xxx___remoteObjectId; cr.
	Transcript show: 'returnProxy: '; show: returnProxy xxx___remoteObjectId; cr."
	self assert: (returnProxy xxx___isProxy).
	self assert: (returnProxy asString = 'Object').! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 16:14'!
testMutualRecursion

	|entryPoint remoteTestClassInstance|

	entryPoint := self connectLocalToRemoteDeamon.
	
	remoteTestClassInstance := (entryPoint at: #MockForMutualRecursion) new.
	localTestClassInstance := MockForMutualRecursion new.

	self assert: (localTestClassInstance decrement: 10 with: remoteTestClassInstance) = 0.! !

!SeamlessDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 21:09'!
testTranscript

	|entryPoint remoteTranscript|
	
	entryPoint := self connectLocalToRemoteDeamon.
	"send the class message"
	remoteTranscript := entryPoint at: #Transcript.

	(1 to: 10) do: [:i | remoteTranscript show: i].! !

SeamlessDeamonTest subclass: #SeamlessRemoteDeamonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!SeamlessRemoteDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 13:09'!
setUp

	localDeamon := SeamlessDeamon newDefaultWithGlobalAccess startOn: 8080.
	! !

!SeamlessRemoteDeamonTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 13:11'!
tearDown

	localDeamon stop.
	! !

TestCase subclass: #SeamlessDistributionControlTest
	instanceVariableNames: 'distributionStrategy proxyClass garbageCollectorClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Control'!

!SeamlessDistributionControlTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/23/2014 18:00'!
setUp

	proxyClass := SeamlessFastDNUProxy.
	garbageCollectorClass := SeamlessDefaultGarbageCollector.
	distributionStrategy := SeamlessDistributionControl new
								initializeWithProxyClass: proxyClass andGarbageCollector: garbageCollectorClass new.! !

!SeamlessDistributionControlTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 14:14'!
testMessageSend

	|proxy interceptedSelector|
	
	proxy := proxyClass new
				xxx___handler: distributionStrategy proxyHandler.
	
	distributionStrategy proxyHandler onMessageInterceptEvaluate: [:process :aProxy :selector :arguments |
							interceptedSelector := selector.
	].
				
	self assert: (proxy xxx___isProxy).
	proxy at: 3 put: 100.
	self assert: (interceptedSelector = #at:put:).! !

TestCase subclass: #SeamlessDistributionPolicyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Policy'!

TestCase subclass: #SeamlessDistributionTableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Table'!

TestCase subclass: #SeamlessFastDNUProxyTest
	instanceVariableNames: 'proxy systemSelectors nonInterceptedSelectors selectorsNotIntercepted proxySelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

!SeamlessFastDNUProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 18:06'!
prepareMessageSendStringForSelector: aSelector
	
	aSelector isUnary ifTrue: [
		
		^ aSelector asString
		
	] ifFalse: [
		
		aSelector isBinary ifTrue: [
		
			^ aSelector asString , 'nil'.
			
		] ifFalse: [
			| messageSendString|
			
			messageSendString := ''.
			
			(aSelector asString findTokens: #($:)) do: [:token |
				messageSendString := messageSendString , token , ': ' , 'nil '.  	
			].
		
			^ messageSendString
		
		]
	
	]! !

!SeamlessFastDNUProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 13:48'!
setUp

	proxy := SeamlessFastDNUProxy new
				xxx___handler: (SeamlessFastDNUProxy defaultHandlerClass new onMessageInterceptEvaluate: [:process :aProxy :selector :arguments |
							nonInterceptedSelectors remove: selector.
				]).
			
	systemSelectors := Set new.
	proxySelectors := SeamlessFastDNUProxy selectors.
	
	ProtoObject withAllSubclasses do: [:class | 
		class allSelectors do: [:selector |
			(proxySelectors includes: selector) ifFalse: [
				systemSelectors add: selector.	
			]
		]	
	].

	nonInterceptedSelectors := systemSelectors copy.
	
	Smalltalk globals at: #TestProxy put: proxy.! !

!SeamlessFastDNUProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 18:06'!
tearDown 
		
	Smalltalk globals removeKey: #TestProxy.! !

!SeamlessFastDNUProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 21:35'!
testAllSystemSelectors

	|expectedNonInterceptedSet|
	
	systemSelectors do: [:selector |
		Compiler evaluate: ('TestProxy ' , (self prepareMessageSendStringForSelector: selector)).	
	].

	Transcript show: nonInterceptedSelectors; cr; cr.
	Transcript show: proxySelectors.

	expectedNonInterceptedSet := Set new.
	expectedNonInterceptedSet add: #==.
	
	self assert: (nonInterceptedSelectors = expectedNonInterceptedSet).! !

TestCase subclass: #SeamlessFuelTranscoderTest
	instanceVariableNames: 'policy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!SeamlessFuelTranscoderTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 15:23'!
policyCallback

	^ policy policyCallback ! !

!SeamlessFuelTranscoderTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2012 12:46'!
setUp

	policy := (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Magnitude . String . Symbol . UndefinedObject}
														classesToPassByShallowCopy: {OrderedCollection . Array}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {} asDictionary  
																				classesNotToReference: {} asDictionary
																				includingMessages: {} asDictionary  
																				excludingMessages: {} asDictionary)) proxyHandler: SeamlessFastDNUProxy defaultHandlerClass new ; proxyClass: SeamlessFastDNUProxy. ! !

!SeamlessFuelTranscoderTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/19/2012 11:41'!
testInnerSerializeMaterialize

	|initialObject transcoder materializedObject|
	
	initialObject := {3 . 41234 . Point new. 'aString' . {2 . Point} asOrderedCollection . Point class } asOrderedCollection.
	
	"with this policyCallback all objects "
	
	
	transcoder := SeamlessFuelTranscoder new.
	materializedObject := transcoder innerMaterializeAnObjectFromData: (transcoder innerShallowSerialize: initialObject  withPolicyCallback:  self policyCallback) withPolicyCallback: self policyCallback.
	self assert: (((materializedObject at: 5) at: 2) xxx___isProxy) = true. "for the time being inner classes are passed by value -- of some short"
	self assert: ((materializedObject at: 6) xxx___isProxy) = true! !

!SeamlessFuelTranscoderTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:17'!
testSerializeMaterialize

	|initialObject transcoder|
	
	initialObject := (1 to: 1000000).
	
	transcoder := SeamlessFuelTranscoder new.
	
	self assert: (initialObject = (transcoder materialize: (transcoder serialize: initialObject))).! !

!SeamlessFuelTranscoderTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2012 12:28'!
testShallowSerializeMaterialize

	|initialObject transcoder materializedObject|
	
	initialObject := SeamlessMessageSendRequest new initializeWithReceiver: RestoreProxiedObjectWrapper new selector: #stmth arguments: {ShallowSerializedObjectWrapper new serializedObject: {3 . 41234 . 'aString' . Point new} asOrderedCollection } processId: 34.
	
	"with this policyCallback all objects "
	
	
	transcoder := SeamlessFuelTranscoder new.
	materializedObject := transcoder materialize: (transcoder serialize: initialObject usingCallback: self policyCallback) usingCallback: self policyCallback.
	self assert: (materializedObject class = SeamlessMessageSendRequest).
	self assert: ((materializedObject instVarNamed: #argumentWrappersAsArray) at: 1) class = ShallowSerializedObjectWrapper.
	self assert: (((materializedObject instVarNamed: #argumentWrappersAsArray) at: 1) serializedObject at: 4) xxx___isProxy.
	! !

TestCase subclass: #SeamlessGhostProxyTest
	instanceVariableNames: 'proxy systemSelectors nonInterceptedSelectors selectorsNotIntercepted proxySelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:42'!
prepareMessageSendStringForSelector: aSelector
	
	aSelector isUnary ifTrue: [
		
		^ aSelector asString
		
	] ifFalse: [
		
		aSelector isBinary ifTrue: [
		
			^ aSelector asString , 'nil'.
			
		] ifFalse: [
			| messageSendString|
			
			messageSendString := ''.
			
			(aSelector asString findTokens: #($:)) do: [:token |
				messageSendString := messageSendString , token , ': ' , 'nil '.  	
			].
		
			^ messageSendString
		
		]
	
	]! !

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 11:20'!
setUp

	proxy := SeamlessGhostProxy new
				xxx___handler: (SeamlessGhostProxyHandler new onMessageInterceptEvaluate: [:process :aProxy :selector :arguments |
							nonInterceptedSelectors remove: selector.
				]).
			
	systemSelectors := Set new.
	proxySelectors := SeamlessGhostProxy allSelectorsBelow: Object.
	proxySelectors remove: #class.
	proxySelectors remove: #log:.
	"proxySelectors remove: #cannotInterpret:."
	
	ProtoObject withAllSubclasses do: [:class | 
		class allSelectors do: [:selector |
			(proxySelectors includes: selector) ifFalse: [
				systemSelectors add: selector.	
			]
		]	
	].

	nonInterceptedSelectors := systemSelectors copy.
	
	Smalltalk globals at: #TestProxy put: proxy.! !

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:40'!
tearDown 
		
	Smalltalk globals removeKey: #TestProxy.! !

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 21:36'!
testAllSystemSelectors
	
	| expectedNonInterceptedSet |
	systemSelectors do: [:selector |
		Compiler evaluate: ('TestProxy ' , (self prepareMessageSendStringForSelector: selector)).	
	].

	Transcript show: nonInterceptedSelectors; cr; cr.
	Transcript show: proxySelectors.
	
	expectedNonInterceptedSet := Set new.
	expectedNonInterceptedSet add: #==.
	
	self assert: (nonInterceptedSelectors = expectedNonInterceptedSet).! !

TestCase subclass: #SeamlessObjectTransporterTest
	instanceVariableNames: 'numberOfSends peer1 peer2 receivedObjects initialObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Object-Transporter'!

!SeamlessObjectTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 15:27'!
setUp

	initialObject := (1 to: 100000).
	
	receivedObjects := OrderedCollection new.
		
	numberOfSends := 10.

	peer1 := (SeamlessObjectTransporter newWithTransporter: (SeamlessSocketStreamTransporter new) andTranscoder: (SeamlessFuelTranscoder new)).
	(peer1 startOn: 8080) onObjectReceivedEvaluate: [:conId :object |
		receivedObjects add: object.
	].

	peer2 := (SeamlessObjectTransporter newWithTransporter: (SeamlessSocketStreamTransporter new) andTranscoder: (SeamlessFuelTranscoder new)).
	(peer2 startOn: 8081) onObjectReceivedEvaluate: [:conId :object |
		(1 to: numberOfSends) do: [:i |
			peer2 send: object through: (peer2 connectionIds at: 1).
		]
	].
	
	peer1 connectOn: '127.0.0.1:8081'.! !

!SeamlessObjectTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:53'!
tearDown

	peer1 stop.
	peer2 stop.	
! !

!SeamlessObjectTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:57'!
testEcho

	(1 to: numberOfSends) do: [: i |
		peer1 send: initialObject through: (peer1 connectionIds at: 1).
	].

	(Delay forSeconds: 2) wait.
	
	self assert: ((receivedObjects size) = (numberOfSends raisedTo: 2)).
	
	receivedObjects do: [:data |
		self assert: (data = initialObject).
	].

! !

TestCase subclass: #SeamlessProcessManagerTest
	instanceVariableNames: 'processManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Process-Manager'!

!SeamlessProcessManagerTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 12:36'!
setUp

	processManager := SeamlessProcessManager new.! !

!SeamlessProcessManagerTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 12:44'!
testProcessHandling

	|processId|
	
	processId := processManager add: Processor activeProcess.
	
	[
		(Delay forSeconds: 3) wait.
		processManager setReturnValueFor: processId toValue: #(12 45 900).
		processManager resume: processId. 
	] fork.

	processManager suspend: processId.
	self assert: ((processManager returnValueFor: processId) = #(12 45 900)).! !

TestCase subclass: #SeamlessSimpleSocketStreamTransporterTest
	instanceVariableNames: 'peer1 peer2 initialData receivedData numberOfSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessSimpleSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/30/2012 17:48'!
setUp

	initialData := (1 to: 100000) asString asByteArray.
	
	receivedData := OrderedCollection new.
		
	numberOfSends := 10.

	peer1 := (SeamlessSocketStreamTransporter new startOn: 8080) onDataReceivedEvaluate: [:conId :data |
		receivedData add: data.
	].

	peer2 := (SeamlessSocketStreamTransporter new startOn: 8081) onDataReceivedEvaluate: [:conId :data |
		(1 to: numberOfSends) do: [:i |
			peer2 send: data through: (peer2 connectionIds at: 1).
		]
	].
	
	peer1 connectOn: '127.0.0.1:8081'.

	peer2 connectOn: '127.0.0.1:8080'.  
	
! !

!SeamlessSimpleSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 15:23'!
tearDown

	peer1 stop.
	peer2 stop.	
! !

!SeamlessSimpleSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:57'!
testEcho

	(1 to: numberOfSends) do: [: i |
		peer1 send: initialData through: (peer1 connectionIds at: 1).
	].

	(Delay forSeconds: 2) wait.
	
	self assert: ((receivedData size) = (numberOfSends raisedTo: 2)).
	
	receivedData do: [:data |
		self assert: (data = initialData).
	].
! !

TestCase subclass: #SeamlessSocketStreamTransporterTest
	instanceVariableNames: 'peers initialData receivedData numberOfPeers stoppedConnections numberOfSends simulationWaitingTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

SeamlessSocketStreamTransporterTest class
	instanceVariableNames: 'transporterClass'!

SeamlessSocketStreamTransporterTest class
	instanceVariableNames: 'transporterClass'!

!SeamlessSocketStreamTransporterTest class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 13:44'!
initialize

	super initialize.
	self transporterClass: SeamlessSocketStreamTransporter! !

!SeamlessSocketStreamTransporterTest class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 13:37'!
transporterClass
	^ transporterClass! !

!SeamlessSocketStreamTransporterTest class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 13:37'!
transporterClass: anObject
	transporterClass := anObject! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 20:48'!
connectAll

	peers doWithIndex: [:peer :index |
		((index + 1) to: numberOfPeers) do: [:peerIndex |
				peer connectOn: (peers at: peerIndex) serverAddress.
		]
	].! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:42'!
setUp

	initialData := (1 to: 1000000) asString asByteArray.
	receivedData := OrderedCollection new.
	peers := OrderedCollection new.
	stoppedConnections := OrderedCollection new.
	numberOfPeers := 20. "numberOfPeers Transporters, almost numberOfPeers ^ 2 -- sockets and concurrent connections"
	numberOfSends := 20.
	
	(1 to: numberOfPeers) do: [:i |
		peers add: self class transporterClass new.
		receivedData add: OrderedCollection new.	
	]
	! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 20:48'!
startAll
	
	peers doWithIndex: [:peer :index |
			peer startOn: 8080 + index.
	].! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:30'!
stopAll

	peers do: [:peer | peer stop]! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:30'!
tearDown

	self stopAll! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2012 12:28'!
testConnectOn

	self startAll connectAll.
	
	self wait.
	
	peers do: [:peer |
		self assert: (peer connectionIds size = (numberOfPeers - 1)).	
	]! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 21:35'!
testOnDataReceivedEvaluate

	self startAll connectAll.
	
	peers doWithIndex: [:peer :index |
		peer onDataReceivedEvaluate: [:connectionId :data |
			 (receivedData at: index) add: data. 
		]	
	].

	peers doWithIndex: [:peer :index |
		
		[
		
			(peer connectionIds) do: [:connectionId | 	
	
					(1 to: numberOfSends) do: [:i |
					
						[peer send: initialData through: connectionId. Processor activeProcess terminate. ] fork. "multiple threads simulation ?"	
								
					].

			].
		
			Processor activeProcess terminate.
		
		] fork."multiple peers simulation ?"
	
	].

	self wait.
	
	receivedData do: [:dataCollection |
		self assert: (dataCollection size = (numberOfSends*(peers size -1))).
		dataCollection do: [:data |
			self assert: (data = initialData).
		].
	].	
! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 16:01'!
testOnNewConnectionEvaluate

	|connectionIds|
	
	connectionIds := OrderedCollection new.
		
	self startAll.
	
	peers doWithIndex: [:peer :index |
		connectionIds add: OrderedCollection new.
		peer onNewConnectionEvaluate: [:connectionId | (connectionIds at: index) add: connectionId].
	].
	
	peers doWithIndex: [:peer :index |
		peers doWithIndex: [:otherPeer :otherIndex |
			index < otherIndex ifTrue: [
				peer connectOn: otherPeer serverAddress.
			]
		]	
	].

	connectionIds do: [:connectionsPerPeer |
		self assert: (connectionsPerPeer size = (peers size - 1))		
	 ]! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 14:25'!
testStartOn

	self startAll! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 13:08'!
testStop
	
	self startAll connectAll.
	
	peers doWithIndex: [:peer :index |
		stoppedConnections add: OrderedCollection new.
		peer onStoppedEvaluate: [:conId |
			(stoppedConnections at: index) add: conId.
		]	
	].

	self stopAll.

	peers doWithIndex: [:peer :index |
		self assert: ((stoppedConnections at: index) size = (numberOfPeers - 1)).
	].! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2012 12:28'!
wait

	(Delay forSeconds: numberOfPeers) wait.! !

TestCase subclass: #TestPuzzle
	instanceVariableNames: 'puzzle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:35'!
assertAuMoinsDeuxCouleursAutourDe: unPoint
	| positions pieces couleurs |
	positions := self positionsAutourDe: unPoint.
	pieces := positions collect: [:position| puzzle pieceX: position x y: position y].
	couleurs := pieces collect: [:unePiece| unePiece couleur].
	self assert: couleurs asSet size > 1! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 10:48'!
positionsAutourDe: unPoint
	| positions nouveauPoint startDeltaX startDeltaY endDeltaX endDeltaY |
	positions := Set new.
	startDeltaX := unPoint x = 1 ifTrue: [0] ifFalse: [-1].
	startDeltaY := unPoint y = 1 ifTrue: [0] ifFalse: [-1].
	endDeltaX := unPoint x = 10 ifTrue: [0] ifFalse: [1].
	endDeltaY := unPoint y = 10 ifTrue: [0] ifFalse: [1].
	startDeltaX to: endDeltaX do: [:deltaX|
		startDeltaY to: endDeltaY do: [:deltaY|
				positions add: unPoint +(deltaX@deltaY)
	]].
	^positions! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 09:57'!
setUp
	super setUp.
	puzzle := Puzzle new! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:55'!
testAucunePieceSelectionneeApresSelectionDeDeuxPieces
	| tableauPieces piece1 piece2 positionInitialePiece1 positionInitialePiece2 |
	tableauPieces := puzzle pieces asArray.
	piece1 := tableauPieces first.
	piece2 := tableauPieces second.
	puzzle inverserSelectionPieceX: piece1 x y: piece1 y.
	puzzle inverserSelectionPieceX: piece2 x y: piece2 y.
	self assert: (puzzle pieces noneSatisfy: [:unePiece| unePiece estSelectionnee])	
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 17:42'!
testIntervertirDeuxPieces
	| tableauPieces piece1 piece2 positionInitialePiece1 positionInitialePiece2 |
	tableauPieces := puzzle pieces asArray.
	piece1 := tableauPieces first.
	piece2 := tableauPieces second.
	positionInitialePiece1 := piece1 position.
	positionInitialePiece2 := piece2 position.
	puzzle intervertir: piece1 avec: piece2.
	self assert: piece1 position = positionInitialePiece2.
	self assert: piece2 position = positionInitialePiece1.
	
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:55'!
testIntervertirDeuxPiecesSuccessivementSelectionnees
	| tableauPieces piece1 piece2 positionInitialePiece1 positionInitialePiece2 |
	tableauPieces := puzzle pieces asArray.
	piece1 := tableauPieces first.
	piece2 := tableauPieces second.
	positionInitialePiece1 := piece1 position.
	positionInitialePiece2 := piece2 position.
	puzzle inverserSelectionPieceX: piece1 x y: piece1 y.
	puzzle inverserSelectionPieceX: piece2 x y: piece2 y.
	self assert: piece1 position = positionInitialePiece2.
	self assert: piece2 position = positionInitialePiece1.
	
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 17:46'!
testMelangePieces
	| tableauPieces positionsInitiales positionsApresMelange |
	tableauPieces := puzzle pieces asArray.
	positionsInitiales := tableauPieces collect: [:unePiece| unePiece position].
	puzzle melanger.
	positionsApresMelange := tableauPieces collect: [:unePiece| unePiece position].
	self deny: positionsInitiales = positionsApresMelange
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 10:39'!
testNombreDePieces
	self assert: puzzle pieces size = 100! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 11:33'!
testPiecesInitialementColorees
	self deny: (puzzle pieces anySatisfy: [:unePiece| unePiece couleur isNil])! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:40'!
testPiecesInitialementDeselectionnees
	self assert: (puzzle pieces noneSatisfy: [:unePiece| unePiece estSelectionnee])! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 10:46'!
testPositionsDesPieces
	| positions |
	positions := puzzle pieces collect: [:unePiece| unePiece position].
	self assert: positions size = puzzle pieces size.
	self assert: (positions allSatisfy: [:unPoint| unPoint x > 0]).
	self assert: (positions allSatisfy: [:unPoint| unPoint y > 0]).
	self assert: (positions allSatisfy: [:unPoint| unPoint x < 11]).
	self assert: (positions allSatisfy: [:unPoint| unPoint y < 11])
	! !

Dictionary subclass: #SeamlessDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!Class methodsFor: '*Seamless' stamp: 'NickPapoulias 8/20/2012 18:57'!
from: aRemoteAddress

	^ (SeamlessDeamonManager default addressAsRemoteEnvironment: aRemoteAddress) at: self asString asSymbol! !

Object subclass: #AbstractSeamlessConnection
	instanceVariableNames: 'id dataAvailableCallback localAddress remoteAddress incomingDataProcess stopCallback sendSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

AbstractSeamlessConnection class
	instanceVariableNames: 'nextId'!

AbstractSeamlessConnection class
	instanceVariableNames: 'nextId'!

!AbstractSeamlessConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:17'!
initialize
	super initialize.
	nextId := 0! !

!AbstractSeamlessConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 14:53'!
new

	nextId := nextId + 1.
	^ super new id: nextId.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:06'!
cleanUp 

	incomingDataProcess terminate! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 17:02'!
dataReceived: data

	"test asynchronous evaluation of the data received callback"

	dataAvailableCallback ifNotNil: [
		[dataAvailableCallback value: self id value: data.] fork.
	]
	! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 14:52'!
id
	^ id! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 14:52'!
id: anObject
	id := anObject! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 17:20'!
info

	^ SeamlessConnectionInfo new
		id: id;
		localAddress: localAddress;
		remoteAddress: remoteAddress.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 20:49'!
initialize 

	sendSemaphore := Semaphore forMutualExclusion ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:13'!
isConnected

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:28'!
localAddress
	^ localAddress! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:28'!
localAddress: anObject
	localAddress := anObject! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 10:57'!
onDataReceivedEvaluate: aBlock

	dataAvailableCallback := aBlock.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 13:59'!
onStopped

	stopCallback ifNotNil: [
		stopCallback value: self id.
		stopCallback := nil. "normally only one side initiates stop -- we nil the block to avoid duplicated callbacks"
	].

	self cleanUp.
	! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:05'!
onStoppedEvaluate: aBlock

	stopCallback := aBlock.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:09'!
receiveData

	|header|
	
	header := self receiveInteger.
	
	(header = -1) ifTrue: [
		self onStopped.
	] ifFalse: [
		self dataReceived: (self receivePacketSized: header)
	]
	
	! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:53'!
receiveInteger

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:25'!
receivePacketSized: packetSize

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:44'!
remoteAddress
	^ remoteAddress! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:44'!
remoteAddress: anObject
	remoteAddress := anObject! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 16:34'!
sendData: data

	sendSemaphore critical: [

"test asynchronous sending -- in case the concrete implementation
		suspends sending together with the process"
		[self sendPacketSize: data size.
		self sendPacket: data.] fork.
		
	].
		! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:53'!
sendInteger: int32

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 22:10'!
sendPacket: data

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:22'!
sendPacketSize: int32

	self sendInteger: int32.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 16:29'!
sendStop

		self sendInteger: -1
! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:47'!
start

	incomingDataProcess := [
		
		[self receiveData] repeat
		
	] fork.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:50'!
stop

	self isConnected ifTrue: [
		self sendStop.
	].

	self onStopped.! !

AbstractSeamlessConnection subclass: #SeamlessSocketStreamConnection
	instanceVariableNames: 'stream socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

SeamlessSocketStreamConnection class
	instanceVariableNames: 'SocketStreamClass'!

SeamlessSocketStreamConnection class
	instanceVariableNames: 'SocketStreamClass'!

!SeamlessSocketStreamConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 17:58'!
addressAsStringFrom: aByteArray and: aPortNumber
	
	|str|
	
	str := ''.
	
	(1 to: aByteArray size) do: [:index |
		str := str , (aByteArray at: index) asString.
		(index = aByteArray size) ifFalse: [
			str := str , '.'
		] ifTrue: [
			str := str , ':' , aPortNumber asString.
		]
	].
	
	^ str.
	! !

!SeamlessSocketStreamConnection class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:09'!
initialize

	super initialize.
	self socketStreamClass: SocketStream.! !

!SeamlessSocketStreamConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 18:01'!
newOnSocket: aSocket 

	^ self new
		withSocket: aSocket;
		localAddress: (self addressAsStringFrom: aSocket localAddress and: aSocket localPort);
		remoteAddress: (self addressAsStringFrom:  aSocket remoteAddress and: aSocket remotePort).
! !

!SeamlessSocketStreamConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 19:07'!
openConnectionToHost: address port: port
	
	|stream|
	
	stream := self socketStreamClass openConnectionToHost: address port: port. 
	
	^ self new
		withStream: stream;
		localAddress: (self addressAsStringFrom: stream socket localAddress and: stream socket localPort);
		remoteAddress: (self addressAsStringFrom: stream socket remoteAddress and: stream socket remotePort).
! !

!SeamlessSocketStreamConnection class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:08'!
socketStreamClass
	^ SocketStreamClass! !

!SeamlessSocketStreamConnection class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:08'!
socketStreamClass: anObject
	SocketStreamClass := anObject! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:15'!
isConnected 

	^ stream isConnected ! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:54'!
receiveInteger
	"Read a 32-bit signed integer from the next 4 bytes"
	| s |
	s := 0.
	1 to: 4 do: [:i | s := (s bitShift: 8) + stream next asInteger].
	(s bitAnd: 16r80000000) = 0
		ifTrue: [^ s]
		ifFalse: [^ -1 - s bitInvert32]! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:15'!
receivePacketSized: packetSize

	^ (stream next: packetSize)! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/9/2012 11:48'!
sendInteger: int32
	"Write a signed integer to the next 4 bytes"
	| pos |
	pos := int32 < 0
		ifTrue: [(0-int32) bitInvert32 + 1]
		ifFalse: [int32].
	1 to: 4 do: [:i | stream nextPut: (pos digitAt: 5-i)].
	^ int32! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:16'!
sendPacket: data

	stream nextPutAll: data.
	stream flush! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:55'!
stop

	super stop.

	stream close.! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:41'!
withSocket: aSocket 

	socket := aSocket.
	stream := self class socketStreamClass on: socket.
	stream timeout: 0.
	stream binary.! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:41'!
withStream: aStream 

	socket := aStream socket.
	stream := aStream.
	stream timeout: 0.
	stream binary.! !

Object subclass: #AbstractSeamlessTranscoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!AbstractSeamlessTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:18'!
materialize: data

	self subclassResponsibility ! !

!AbstractSeamlessTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:18'!
materialize: data usingCallback: aCallback

	self subclassResponsibility ! !

!AbstractSeamlessTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:54'!
serialize: anObject

	self subclassResponsibility ! !

!AbstractSeamlessTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:19'!
serialize: anObject usingCallback: aCallback

	self subclassResponsibility ! !

AbstractSeamlessTranscoder subclass: #SeamlessFuelTranscoder
	instanceVariableNames: 'optimizedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/19/2012 15:06'!
initialize

	super initialize.
	optimizedClasses := Set new.
	{Integer . Float . Symbol . Bitmap . ByteSymbol . Character . Date . DateAndTime . Duration . Time} do: [:anOptClass |
		optimizedClasses add: anOptClass.
		optimizedClasses addAll: anOptClass allSubclasses.
	].! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2012 11:04'!
innerMaterializeAnObjectFromData: data withPolicyCallback: aCallback

	 |materialization|
	
	materialization := (FLMaterializer  newDefault materializeFrom: (ReadStream on: data)).
	materialization objects do: [:each |
       	(each isKindOf: ObjectWrapper) ifTrue: [
			each become: (aCallback value: each value: #materializeFromWrapper).	
		] 	
	].
	^ materialization root.! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/19/2012 11:38'!
innerShallowSerialize: anObject withPolicyCallback: aCallback

	|stream serializer |
	
	stream := WriteStream on: ByteArray new.
	serializer := FLSerializer newDefault.
	
	serializer analyzer 
		when: [:obj | true ]
		substituteBy: [:obj | aCallback value: obj value: #serialize].
	
	(serializer serialize: anObject on: stream).
	"self halt."	
	^ stream contents.! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:17'!
materialize: data

	 ^ (FLMaterializer  newDefault materializeFrom: (ReadStream on: data)) root.! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:16'!
materialize: data usingCallback: aCallback

	 |materialization|
	
	materialization := (FLMaterializer  newDefault materializeFrom: (ReadStream on: data)).
	materialization objects do: [:each |
       	(each class = ShallowSerializedObjectWrapper) ifTrue: [ 
			each serializedObject: (self innerMaterializeAnObjectFromData: (each serializedObject) withPolicyCallback: aCallback).  
		]
	].
	^ materialization root.! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 20:13'!
serialize: anObject

	|stream|
	
	stream := WriteStream on: ByteArray new.

	(FLSerializer newDefault serialize: anObject on: stream).
	
	^ stream contents.! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 15:37'!
serialize: anObject usingCallback: aCallback

	|stream serializer|
	
	stream := WriteStream on: ByteArray new.
	serializer := FLSerializer newDefault.
	
	serializer analyzer 
		when: [:obj | obj class = ShallowSerializedObjectWrapper ]
		substituteBy: [:obj |
			obj serializedObject: (self innerShallowSerialize:  obj serializedObject withPolicyCallback: aCallback).
		].
	
	(serializer serialize: anObject on: stream).
	
	^ stream contents.! !

Object subclass: #AfficheurPuzzle
	instanceVariableNames: 'vue puzzle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!AfficheurPuzzle methodsFor: 'mise a jour' stamp: 'NouryBouraqadi 9/28/2012 18:50'!
couleurBordParDefaut
	^Color gray! !

!AfficheurPuzzle methodsFor: 'mise a jour' stamp: 'NouryBouraqadi 9/28/2012 18:49'!
couleurBordSelection
	^Color black ! !

!AfficheurPuzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:46'!
pieces
	^self puzzle pieces! !

!AfficheurPuzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:46'!
puzzle
	^puzzle! !

!AfficheurPuzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:57'!
puzzle: unPuzzle vue: aGridMorph
	puzzle := unPuzzle.
	vue := aGridMorph.
	vue rowCount: 10 columnCount: 10.
	self pieces do: [:unePiece|
		vue color: unePiece couleur at: unePiece x at: unePiece y.
		unePiece addDependent: self]! !

!AfficheurPuzzle methodsFor: 'mise a jour' stamp: 'NouryBouraqadi 9/28/2012 18:49'!
update: unePiece
	| couleurBord |
	self vue color: unePiece couleur at: unePiece x at: unePiece y.
	couleurBord := unePiece estSelectionnee ifTrue: [self couleurBordSelection] ifFalse: [self couleurBordParDefaut].
	self vue borderColor: couleurBord at:  unePiece x at: unePiece y! !

!AfficheurPuzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:58'!
vue
	^vue! !

Object subclass: #AppliPuzzleDistant
	instanceVariableNames: 'puzzle afficheur vue middleware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

AppliPuzzleDistant class
	instanceVariableNames: 'default'!

!AppliPuzzleDistant commentStamp: '<historical>' prior: 0!
Pour lancer, évealuer l'expression suivante :
AppliPuzzle demarrer

Instance Variables:
	puzzle	<Puzzle>
	afficheur	<AfficheurPuzzle>
	vue	<GridMorph>!

AppliPuzzleDistant class
	instanceVariableNames: 'default'!

!AppliPuzzleDistant class methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:30'!
arreter
	self default arreter! !

!AppliPuzzleDistant class methodsFor: 'instance par defaut' stamp: 'NouryBouraqadi 9/30/2013 11:30'!
default
	^default ifNil: [ default := self new ]! !

!AppliPuzzleDistant class methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:30'!
demarrer
	self default demarrer! !

!AppliPuzzleDistant methodsFor: 'arret' stamp: 'NouryBouraqadi 9/30/2013 11:31'!
arreter
	self arreterAffichage.
	self arreterMiddleware.! !

!AppliPuzzleDistant methodsFor: 'arret' stamp: 'NouryBouraqadi 9/30/2013 11:32'!
arreterAffichage
	vue delete! !

!AppliPuzzleDistant methodsFor: 'arret' stamp: 'NouryBouraqadi 9/30/2013 11:31'!
arreterMiddleware
	middleware ifNil: [ ^self ].
	middleware stop! !

!AppliPuzzleDistant methodsFor: 'lancement' stamp: 'NickPapoulias 9/30/2013 19:35'!
connexionAuBackEnd
	| classePuzzleDistante |
	classePuzzleDistante := (middleware connectOn: '127.0.0.1:1111') at: #Puzzle.
	puzzle := classePuzzleDistante new.
	afficheur := AfficheurPuzzle new.
	afficheur puzzle: puzzle vue: vue.
	vue onClickDo: [:x :y| 
		Transcript show: 'sending'; cr.
		puzzle inverserSelectionPieceX: x y: y.
	]! !

!AppliPuzzleDistant methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 10:47'!
demarrer
	self demarrerMiddleware.
	self connexionAuBackEnd.
	self demarrerAffichage! !

!AppliPuzzleDistant methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 10:46'!
demarrerAffichage
	| window |
	window := vue openInWindowLabeled: self titreFenetre.
	window beWithoutGrips.
	window removeExpandBox! !

!AppliPuzzleDistant methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:41'!
demarrerMiddleware
	self arreterMiddleware.
	middleware := SeamlessDeamon newDefaultWithGlobalAccess.
	middleware startOn: 2222.
	! !

!AppliPuzzleDistant methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/30/2013 11:40'!
initialize
	super initialize.
	afficheur := AfficheurPuzzle new.
	vue := GridMorph new.
	vue cellExtent: self tailleAffichageUnePiece.
! !

!AppliPuzzleDistant methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 16:32'!
puzzle
	^puzzle! !

!AppliPuzzleDistant methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/28/2012 16:31'!
tailleAffichageUnePiece
	^50@50! !

!AppliPuzzleDistant methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/28/2012 16:11'!
titreFenetre
	^'Puzzle Objets Distribués (ISIC)'! !

!AppliPuzzleDistant methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 16:32'!
vue
	^vue! !

Object subclass: #BackEndAppliPuzzleDistribue
	instanceVariableNames: 'middleware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

BackEndAppliPuzzleDistribue class
	instanceVariableNames: 'default'!

!BackEndAppliPuzzleDistribue commentStamp: 'NouryBouraqadi 10/3/2012 11:59' prior: 0!
Utiliser avec InterfaceAppliPuzzleDistribue sur 2 images différentes. L'image 1 doit contenir le code pour le BackEnd et la catégorie Puzzle. L'image2 doit contenir le code pour l'interface et la catégorie GridView. Les 2 images doivent contenir SimpleMiddleware.

Pour lancer l'exemple du Puzzle distribuer, exécuter les codes suivants dans des workspaces des imags indiquées. Respecter l'ordre.

"Image 1"
backEnd := BackEndAppliPuzzleDistribue new.

"Image 2"
interface := InterfaceAppliPuzzleDistribue new.

"Image 1"
backEnd finInitialisation.

"Image 2"
interface finInitialisation.
interface demarrer.

Pour arrêter l'application (arrêter les middleware), exécuter:
"Image 1"
backEnd stop.

"Image 2"
interface stop.
!

BackEndAppliPuzzleDistribue class
	instanceVariableNames: 'default'!

!BackEndAppliPuzzleDistribue class methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:36'!
arreter
	self default arreter! !

!BackEndAppliPuzzleDistribue class methodsFor: 'instance par defaut' stamp: 'NouryBouraqadi 9/30/2013 11:37'!
default
	^default ifNil: [ default := self new ]! !

!BackEndAppliPuzzleDistribue class methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:35'!
demarrer
	self default demarrer! !

!BackEndAppliPuzzleDistribue methodsFor: 'activite' stamp: 'NouryBouraqadi 9/30/2013 11:36'!
arreter
	middleware ifNil: [ ^self ].
	middleware stop! !

!BackEndAppliPuzzleDistribue methodsFor: 'activite' stamp: 'NouryBouraqadi 9/30/2013 11:36'!
demarrer
	self arreter.
	middleware := SeamlessDeamon newDefaultWithGlobalAccess.
	middleware startOn: 1111! !

Object subclass: #By
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!By class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 22:16'!
value: anObject

	^ SerializedObjectWrapper new serializedObject: anObject! !

Object subclass: #Contact
	instanceVariableNames: 'firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

Contact class
	instanceVariableNames: 'database'!

!Contact commentStamp: 'estelle 2/3/2011 08:08' prior: 0!
I have informations about people. I can store created instances.

|someone|
someone := Contact new firstName: 'Miles'; lastName:'Davis'.
Contact database add: someone.

self assert: Contact database last firstName = 'Miles'.
self assert: Contact database last lastName = 'Davis'.!

Contact class
	instanceVariableNames: 'database'!

!Contact class methodsFor: 'accessing' stamp: 'LaurentLaffont 1/22/2011 18:12'!
database
	^ database ifNil: [database := OrderedCollection new]! !

!Contact class methodsFor: 'accessing' stamp: 'NickPapoulias 10/23/2014 14:26'!
database: anOrderedCollection
	database := anOrderedCollection! !

!Contact methodsFor: 'accessing' stamp: 'LaurentLaffont 1/23/2011 10:20'!
firstName
	^ firstName ifNil: [firstName := 'unknown']! !

!Contact methodsFor: 'accessing' stamp: 'LaurentLaffont 1/22/2011 18:11'!
firstName: anObject
	firstName := anObject! !

!Contact methodsFor: 'accessing' stamp: 'LaurentLaffont 1/23/2011 10:19'!
lastName
	^ lastName ifNil: [lastName := 'unknown']! !

!Contact methodsFor: 'accessing' stamp: 'LaurentLaffont 1/22/2011 18:11'!
lastName: anObject
	lastName := anObject! !

!Contact methodsFor: 'printing' stamp: 'LaurentLaffont 1/22/2011 18:15'!
printOn: aStream
	aStream
		nextPutAll: self className;
		nextPutAll: '(';
		nextPutAll: self firstName;
		nextPutAll: ' ';
		nextPutAll: self lastName;
		nextPutAll: ')'.! !

Object subclass: #ContactEditor
	instanceVariableNames: 'contact onOKAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!ContactEditor commentStamp: 'estelle 2/3/2011 08:06' prior: 0!
Dialog to edit a Contact. For example:

ContactEditor new
	contact: (Contact new firstName: 'Miles'; lastName:'Davis');
	openModal.!

!ContactEditor methodsFor: 'accessing' stamp: 'LaurentLaffont 1/23/2011 10:08'!
contact: aContact 
	contact := aContact! !

!ContactEditor methodsFor: 'ok actions' stamp: 'LaurentLaffont 1/23/2011 13:50'!
doOnOK
	^ self onOK value! !

!ContactEditor methodsFor: 'ok actions' stamp: 'LaurentLaffont 1/23/2011 13:50'!
onOK
	^ onOKAction ifNil: [onOKAction := []].! !

!ContactEditor methodsFor: 'ok actions' stamp: 'LaurentLaffont 1/23/2011 13:50'!
onOK: aBlock
	onOKAction := aBlock! !

!ContactEditor methodsFor: 'open/close' stamp: 'LaurentLaffont 1/25/2011 21:15'!
openModal
	|builder dialog content firstName|
 
	builder := UITheme builder.
 	content := (builder newLabelGroup: {
  			'First name' -> (firstName := (builder
   											newTextEntryFor: contact 
											getText: #firstName 
											setText: #firstName: 
											help: 'Enter the first name of the contact')
   										acceptOnCR: false;
   										minWidth: 200).
  			'Last name' -> ((builder
   							newTextEntryFor: contact 
							getText: #lastName 
							setText: #lastName: 
							help: 'Enter the last name of the contact')
   						acceptOnCR: false;
   						minWidth: 200) 
	}).
 
	dialog := builder newPluggableDialogWindow:'Edit contact' for: content.
	dialog rememberKeyboardFocus: firstName.
	builder openModal: dialog.
 
	dialog cancelled ifFalse: [self doOnOK].! !

Object subclass: #ContactListEditor
	instanceVariableNames: 'selectedContactIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!ContactListEditor commentStamp: 'estelle 2/3/2011 08:03' prior: 0!
Window to add / remove / edit a list of Contact.

Open with 

ContactListEditor new open.!

!ContactListEditor class methodsFor: 'menu' stamp: 'LaurentLaffont 1/28/2011 21:38'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'Manage contacts')
			action:[ self open].! !

!ContactListEditor class methodsFor: 'instance creation' stamp: 'LaurentLaffont 1/23/2011 11:10'!
open
	^ self new open.! !

!ContactListEditor methodsFor: 'callback' stamp: 'LaurentLaffont 1/25/2011 21:23'!
addButtonClick
	|newContact|
	newContact := Contact new.
	
	ContactEditor new
		contact: newContact;
		onOK: [	Contact database add: newContact.  
				selectedContactIndex := Contact database size.
				self 
					changed: #contacts;
					changed: #hasSelectedContact];
		openModal.
		
	! !

!ContactListEditor methodsFor: 'accessing' stamp: 'LaurentLaffont 1/25/2011 21:17'!
contactSelectedIndex
	^ selectedContactIndex ifNil: [selectedContactIndex := 0]! !

!ContactListEditor methodsFor: 'callback' stamp: 'LaurentLaffont 1/25/2011 21:17'!
contactSelectedIndex: aSmallInteger 
	selectedContactIndex := aSmallInteger.
	self 
		changed: #contactSelectedIndex;
  		changed: #hasSelectedContact! !

!ContactListEditor methodsFor: 'accessing' stamp: 'LaurentLaffont 1/23/2011 14:07'!
contacts
	^ Contact database collect: [:aContact| 
		', ' join: {aContact lastName.  aContact firstName}
	].! !

!ContactListEditor methodsFor: 'callback' stamp: 'LaurentLaffont 1/28/2011 21:39'!
editButtonClick
	ContactEditor new
		contact: (Contact database at: selectedContactIndex);
		openModal.
		
	self changed: #contacts.! !

!ContactListEditor methodsFor: 'accessing' stamp: 'LaurentLaffont 1/25/2011 21:18'!
hasSelectedContact
	^selectedContactIndex > 0! !

!ContactListEditor methodsFor: 'open/close' stamp: 'LaurentLaffont 1/28/2011 21:49'!
open
|builder content|
builder := UITheme builder.
content := builder newColumn: {   
	builder 
		newListFor: self   
		list: #contacts
		selected: #contactSelectedIndex
		changeSelected: #contactSelectedIndex:
		help: 'contacts'.
	builder newRow: {
		builder	newButtonFor: self 
								action: #addButtonClick 
								label: 'Add' 
								help: 'Create a new contact'.
		builder newButtonFor: self 
								action: #removeButtonClick 
								getEnabled: #hasSelectedContact 
								label: 'Remove' 
								help: 'Remove selected contact'.
		builder newButtonFor: self 
								action: #editButtonClick 
								getEnabled: #hasSelectedContact 
								label: 'Edit' 
								help: 'Edit selected contact'  }}.
								
(content openInWindowLabeled: 'Contacts') extent: 400@500.! !

!ContactListEditor methodsFor: 'callback' stamp: 'LaurentLaffont 1/25/2011 21:21'!
removeButtonClick
	
	[Contact database removeAt: selectedContactIndex]
		on: Error 
		do: [UITheme builder alert: 'Cannot remove selected contact.'].
		
	self
  		contactSelectedIndex: (self contactSelectedIndex min: Contact database size);
  		changed: #contacts  ! !

Object subclass: #MockForMutualRecursion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!MockForMutualRecursion methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 18:00'!
decrement: value with: aRemoteObject

	value = 0 ifTrue: [
		^ value 	
	] ifFalse: [
		^ aRemoteObject decrement: value - 1 with: self
	]! !

!MockForMutualRecursion methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 20:54'!
decrement: value with: aRemoteObject using: aBlock

	value = 0 ifTrue: [
		^ value 	
	] ifFalse: [
		^ aRemoteObject decrement: (aBlock value: value) with: self using: [:v | aBlock value: v ]
	]! !

!MockForMutualRecursion methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 21:00'!
decrement: value with: aRemoteObject using: aBlock passing: aString

	value = 0 ifTrue: [
		^ value 	
	] ifFalse: [
		^ aRemoteObject decrement: (aBlock value: value) with: self using: [:v | aBlock value: v ] passing: (1 to: 10000000) asOrderedCollection asString.
	]! !

Object subclass: #MockObjectWrapper
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!MockObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 7/18/2012 12:41'!
object
	^ object! !

!MockObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 7/18/2012 12:41'!
object: anObject
	object := anObject! !

!MockObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 7/18/2012 12:41'!
resolveWith: anObject

	^ object! !

!Object methodsFor: '*Seamless' stamp: 'NickPapoulias 9/5/2012 21:13'!
asLocalObject

	^ By value: self! !

!Object methodsFor: '*Seamless' stamp: 'NickPapoulias 1/13/2013 17:30'!
asShallowCopy

	^ ShallowSerializedObjectWrapper new serializedObject: self! !

!Object methodsFor: '*Seamless' stamp: 'NickPapoulias 8/20/2012 17:58'!
from: aRemoteAddress

	^ (SeamlessDeamonManager default addressAsRemoteEnvironment: aRemoteAddress) at: (Smalltalk globals keyAtValue: self) ! !

!Object methodsFor: '*Seamless' stamp: 'NickPapoulias 9/5/2012 21:56'!
resolve

	^ self! !

!Object methodsFor: '*Seamless' stamp: 'NickPapoulias 5/29/2012 14:43'!
xxx___isProxy

	^ false! !

Object subclass: #ObjectWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

ObjectWrapper subclass: #CreateNewProxyWrapper
	instanceVariableNames: 'remoteObjectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

CreateNewProxyWrapper subclass: #CreateNewProxyForAnotherSessionWrapper
	instanceVariableNames: 'sessionInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!CreateNewProxyForAnotherSessionWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:49'!
resolveWith: aDistributionPolicy 

	^ aDistributionPolicy resolveCreateNewProxyWrapperWithRemoteId: remoteObjectId forAnotherSessionWithInfo: sessionInfo! !

!CreateNewProxyForAnotherSessionWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2012 15:09'!
sessionInfo
	^ sessionInfo! !

!CreateNewProxyForAnotherSessionWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2012 15:09'!
sessionInfo: anObject
	sessionInfo := anObject! !

!CreateNewProxyWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:12'!
remoteObjectId
	^ remoteObjectId! !

!CreateNewProxyWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:12'!
remoteObjectId: anObject
	remoteObjectId := anObject! !

!CreateNewProxyWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 6/3/2012 21:05'!
resolveWith: aDistributionPolicy 

	"Transcript show: 'Resolving proxy wrapper with id: '; show: remoteObjectId; cr."

	^ aDistributionPolicy resolveCreateNewProxyWrapperWithRemoteId: remoteObjectId! !

!ObjectWrapper methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2012 10:17'!
resolveWith: aDistributionPolicy

	self subclassResponsibility ! !

ObjectWrapper subclass: #RestoreProxiedObjectWrapper
	instanceVariableNames: 'localObjectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!RestoreProxiedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:13'!
localObjectId
	^ localObjectId! !

!RestoreProxiedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:13'!
localObjectId: anObject
	localObjectId := anObject! !

!RestoreProxiedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:51'!
resolveWith: aDistributionPolicy 

	^ aDistributionPolicy resolveRestoreProxiedObjectWrapperWithLocalObjectId: localObjectId ! !

ObjectWrapper subclass: #SerializedObjectWrapper
	instanceVariableNames: 'serializedObject isShallow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SerializedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 22:19'!
doesNotUnderstand: aMessage

	"if by accident the object wrapper remained locally (with the by value: syntax) act as a proxy"
	
	self becomeForward: serializedObject.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!SerializedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 9/5/2012 21:24'!
resolve

	^ serializedObject ! !

!SerializedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 6/1/2012 10:43'!
resolveWith: aDistributionPolicy 

	^ aDistributionPolicy resolveSerializedObjectWrapper: self! !

!SerializedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 6/1/2012 11:01'!
serializedObject

	^ serializedObject! !

!SerializedObjectWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 6/1/2012 11:01'!
serializedObject: anObject

	serializedObject := anObject! !

SerializedObjectWrapper subclass: #ShallowSerializedObjectWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!ShallowSerializedObjectWrapper methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/8/2012 13:58'!
resolveWith: aDistributionPolicy 

	^ aDistributionPolicy resolveSerializedObjectWrapper: self! !

Object subclass: #Piece
	instanceVariableNames: 'position couleur estSelectionnee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!Piece methodsFor: 'observation' stamp: 'NouryBouraqadi 9/27/2012 11:24'!
addDependent: unObservateur
	super addDependent: unObservateur.
	self changed! !

!Piece methodsFor: 'accessing' stamp: 'NickPapoulias 9/30/2013 22:43'!
couleur
	^ By value: couleur! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 11:25'!
couleur: uneCouleur
	couleur := uneCouleur.
	self changed! !

!Piece methodsFor: 'selectionner' stamp: 'NouryBouraqadi 9/27/2012 16:55'!
deselectionner
	self estSelectionnee: false! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:18'!
estSelectionnee
	^estSelectionnee! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:26'!
estSelectionnee: unBooleen
	estSelectionnee := unBooleen.
	self changed! !

!Piece methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/27/2012 12:19'!
initialize 
	super initialize.
	self estSelectionnee: false! !

!Piece methodsFor: 'selectionner' stamp: 'NouryBouraqadi 9/28/2012 18:39'!
inverserSelection
	self estSelectionnee: self estSelectionnee not! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 10:47'!
position
	^position! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:26'!
position: unPoint
	position := unPoint.
	self changed! !

!Piece methodsFor: 'selectionner' stamp: 'NouryBouraqadi 9/28/2012 19:04'!
selectionner
	self estSelectionnee: true! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:44'!
x
	^self position x! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:44'!
y
	^self position y! !

Object subclass: #ProcessMigrationExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!ProcessMigrationExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/13/2012 17:58'!
runExperiment

| localDeamon remoteEnvironment remoteCompiler remoteBlock|
localDeamon := SeamlessDeamon newDefaultWithProcessMigration startOn: 8080.

remoteEnvironment := localDeamon connectOn: '127.0.0.1:8081'.

remoteCompiler := remoteEnvironment at: #Compiler.

remoteBlock := remoteCompiler evaluate: '[:aProcess | aProcess resume. Transcript show: ''hey...!!''; cr]'.

[remoteBlock value: [(1 to: 100) do: [:i | Transcript show: i; cr]] newProcess] fork.

(Delay forSeconds: 2) wait.

localDeamon stop.! !

Object subclass: #Puzzle
	instanceVariableNames: 'pieces pieceSelectionnee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!Puzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:15'!
couleursDeBase
	^{Color red. Color cyan. Color green. Color yellow. Color magenta}.
! !

!Puzzle methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/27/2012 17:39'!
initialize 
	| unePiece positions unePosition |
	super initialize.
	pieces := Set new.
	self couleursDeBase do: [:uneCouleur|
		20 timesRepeat: [
				unePiece := Piece new.
				unePiece couleur: uneCouleur.
				pieces add: unePiece
			]
	].
	self melanger
! !

!Puzzle methodsFor: 'manipuler pieces' stamp: 'NouryBouraqadi 9/27/2012 17:44'!
intervertir: piece1 avec: piece2 
	|positionInitialePiece1|
	positionInitialePiece1 := piece1 position.
	piece1 position: piece2 position.
	piece2 position: positionInitialePiece1! !

!Puzzle methodsFor: 'manipuler pieces' stamp: 'NouryBouraqadi 10/3/2012 12:08'!
inverserSelectionPieceX: x y: y
	| pieceAInverser |
	pieceAInverser :=  self pieceEn: x@y.
	pieceAInverser inverserSelection.
	pieceSelectionnee ifNil: [
		pieceSelectionnee := pieceAInverser.
		^x@y].
	pieceSelectionnee == pieceAInverser ifFalse: [
		self intervertir: pieceAInverser avec: pieceSelectionnee.
		pieceAInverser deselectionner.
		pieceSelectionnee deselectionner].
	pieceSelectionnee := nil.
	^x@y! !

!Puzzle methodsFor: 'manipuler pieces' stamp: 'NouryBouraqadi 9/27/2012 18:02'!
melanger
	| piecesAMelanger unePiece |
	piecesAMelanger := self pieces copy.
	1 to: 10 do: [:x|
		1 to: 10 do: [:y|
			unePiece := piecesAMelanger atRandom.
			piecesAMelanger remove: unePiece.
			unePiece position: x@y
		]
	].
! !

!Puzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 10:49'!
pieceEn: aPoint 
	^self pieces detect: [:unePiece| unePiece position = aPoint]! !

!Puzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 10:39'!
pieces
	^ pieces! !

Object subclass: #SeamlessAbstractTransporter
	instanceVariableNames: 'incomingConnectionsProcess seamlessConnections dataAvailableCallback newConnectionCallback stoppedCallback serverAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

SeamlessAbstractTransporter class
	instanceVariableNames: 'seamlessConnectionClass'!

SeamlessAbstractTransporter class
	instanceVariableNames: 'seamlessConnectionClass'!

!SeamlessAbstractTransporter class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:59'!
seamlessConnectionClass
	^ seamlessConnectionClass! !

!SeamlessAbstractTransporter class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:59'!
seamlessConnectionClass: anObject
	seamlessConnectionClass := anObject! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:38'!
addNewConnection: aSeamlessConnection

	seamlessConnections at: aSeamlessConnection id put: aSeamlessConnection.
	self newConnectionAdded: aSeamlessConnection.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:40'!
connectOn: aRemoteAddressAsString

	self subclassResponsibility.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 15:50'!
connectionIds

	^ seamlessConnections keys.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 17:17'!
connectionInfoFor: aConnectionId

	^ (seamlessConnections at: aConnectionId) info
	! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:23'!
handleConnectionRequests

	self subclassResponsibility ! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 14:07'!
initialize 

	super initialize.
	seamlessConnections := Dictionary new.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:39'!
newConnectionAdded: aSeamlessConnection

	newConnectionCallback ifNotNil: [newConnectionCallback value: aSeamlessConnection id].! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 09:28'!
onDataReceivedEvaluate: aBlock

	dataAvailableCallback := aBlock.
	seamlessConnections do: [:sConnection |
		sConnection onDataReceivedEvaluate: aBlock.	
	]! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2012 16:12'!
onNewConnectionEvaluate: aBlock

	newConnectionCallback := aBlock.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:43'!
onStoppedEvaluate: aBlock

	stoppedCallback := aBlock.
	seamlessConnections do: [:sConnection |
		sConnection onStoppedEvaluate:  aBlock.	
	]! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:00'!
send: dataAsByteArray through: aSeamlessConnectionId

	(seamlessConnections at: aSeamlessConnectionId) sendData: dataAsByteArray.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 08:49'!
serverAddress

	^ serverAddress! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 08:50'!
serverAddress: aServerIdentifier

	serverAddress := aServerIdentifier ! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 20:09'!
start

	incomingConnectionsProcess := [ 
	
			      self handleConnectionRequests.
	
	] fork! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:35'!
startOn: anIdentifier

	self subclassResponsibility ! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 14:55'!
stop

	seamlessConnections ifNotNil: [
		seamlessConnections keysDo: [:aConnectionId | 
			self stop: aConnectionId.	
		]
	].

	incomingConnectionsProcess ifNotNilDo: [:process | process terminate. incomingConnectionsProcess := nil ].
	! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 14:59'!
stop: aSeamlessConnectionId

	(seamlessConnections at: aSeamlessConnectionId) stop.! !

SeamlessAbstractTransporter subclass: #SeamlessSocketStreamTransporter
	instanceVariableNames: 'serverSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessSocketStreamTransporter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 12:59'!
initialize

	super initialize.
	self seamlessConnectionClass: SeamlessSocketStreamConnection.! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:20'!
connectOn: aRemoteAddressAsString
	
	|clientStream address port newConnection|

	address := ByteArray new writeStream.
	
	((aRemoteAddressAsString findTokens: #($. $:)) doWithIndex: [:item :index |
		(index < 5) ifTrue: [
			address nextPut: item asInteger		
		] ifFalse: [
			port := item asInteger
		]	
	]).
	
	newConnection := (self class seamlessConnectionClass openConnectionToHost: address contents port: port)
									onDataReceivedEvaluate: dataAvailableCallback;
									start.
	
	self addNewConnection: newConnection.
	
	^ newConnection id.

! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 20:09'!
handleConnectionRequests

	|clientSocket|
	
	[
	
		clientSocket := serverSocket waitForAcceptFor: 10.
		clientSocket ifNotNil: [ 
				| newConnection |
				newConnection := (self class seamlessConnectionClass newOnSocket: clientSocket)
									onDataReceivedEvaluate: dataAvailableCallback;
									start.
				self addNewConnection: newConnection 
		]
	
	] repeat ! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 12:56'!
start

	self startOn: 8080.! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:25'!
startOn: aPortNumber

	| clientSocket stream aPortAsString |

	aPortAsString := aPortNumber asString.

	(serverSocket := Socket newTCP)
		setOption: 'TCP_NODELAY' value: 1;
		setOption: 'SO_SNDBUF' value: 4096;
		setOption: 'SO_RCVBUF' value: 4096.

	serverSocket listenOn: aPortAsString asNumber backlogSize: 32.

	serverSocket isValid
		ifFalse: [ self error: 'Cannot create socket on port ' , aPortAsString ].
		
	self serverAddress: '127.0.0.1:' , aPortAsString.

	super start! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 15:04'!
stop
	
	super stop.
	
	serverSocket ifNotNil: [ serverSocket destroy].! !

Object subclass: #SeamlessAuthenticationManager
	instanceVariableNames: 'groups users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Authentication-Manager'!

!SeamlessAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 16:04'!
addGroup: aGroupName withPolicy: aPolicy

	groups at: aGroupName put: (SeamlessUserGroup new
									groupName: aGroupName; 
									distributionPolicy: aPolicy).! !

!SeamlessAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 19:07'!
addUser: aUserName withPassword: aPassword inGroup: aGroupName

	users at: aUserName put: (SeamlessUser new
									username: aUserName;
									password: aPassword;
									group: (groups at: aGroupName)).
					! !

!SeamlessAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 19:05'!
authenticate: seamlessUserCredentials

	|username password|
	
	username := seamlessUserCredentials username.
	password := seamlessUserCredentials password.
	
	((users keys includes: username) & ((users at: username) password = password)) ifTrue: [
		^ (users at: seamlessUserCredentials username) group distributionPolicy cleanCopy	
	] ifFalse: [
		self error: 'Seamless: wrong username or password'
	]! !

!SeamlessAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 16:03'!
initialize

	groups := Dictionary new.
	users := Dictionary new.! !

Object subclass: #SeamlessCleanUpExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

Object subclass: #SeamlessConnectionInfo
	instanceVariableNames: 'id localAddress remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

!SeamlessConnectionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:19'!
id
	^ id! !

!SeamlessConnectionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:19'!
id: anObject
	id := anObject! !

!SeamlessConnectionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:19'!
localAddress
	^ localAddress! !

!SeamlessConnectionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:19'!
localAddress: anObject
	localAddress := anObject! !

!SeamlessConnectionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:19'!
remoteAddress
	^ remoteAddress! !

!SeamlessConnectionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:19'!
remoteAddress: anObject
	remoteAddress := anObject! !

Object subclass: #SeamlessDeamon
	instanceVariableNames: 'sessions objectTransporter shallowCopyFlag exceptionForwarding logging'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/1/2013 16:02'!
newDefaultWithGlobalAccess

	^ self new
		buildWithTransporterClass: SeamlessSocketStreamTransporter 
		transcoderClass: SeamlessFuelTranscoder 
		proxyClass: SeamlessFastDNUProxy "SeamlessGhostProxy"
		garbageCollectorClass: SeamlessDefaultGarbageCollector
		andAuthenticationManager: ((SeamlessAuthenticationManager new)
										addGroup: 'default'
										withPolicy: (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Character . Number . String . Symbol . UndefinedObject . Color}
														classesToPassByShallowCopy: {}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {} asOrderedCollection
																				classesNotToReference: {} asOrderedCollection
																				includingMessages: {} asDictionary  
																				excludingMessages: {} asDictionary));
										addUser: 'default' withPassword: '' inGroup: 'default')
		shallowCopyEnabled: false.! !

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/13/2012 13:46'!
newDefaultWithProcessMigration

	^ self new
		buildWithTransporterClass: SeamlessSocketStreamTransporter 
		transcoderClass: SeamlessFuelTranscoder 
		proxyClass: SeamlessFastDNUProxy "SeamlessGhostProxy"
		garbageCollectorClass: SeamlessDefaultGarbageCollector
		andAuthenticationManager: ((SeamlessAuthenticationManager new)
										addGroup: 'default'
										withPolicy: (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Magnitude . String . Symbol . UndefinedObject . SeamlessOrderedCollection . Process}
														classesToPassByShallowCopy: {}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {} asDictionary  
																				classesNotToReference: {} asDictionary
																				includingMessages: {} asDictionary  
																				excludingMessages: {} asDictionary));
										addUser: 'default' withPassword: '' inGroup: 'default')
		shallowCopyEnabled: false.! !

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/25/2012 01:19'!
newWithRestrictedAccess

	^ self new
		buildWithTransporterClass: SeamlessSocketStreamTransporter 
		transcoderClass: SeamlessFuelTranscoder 
		proxyClass: SeamlessFastDNUProxy "SeamlessGhostProxy"
		garbageCollectorClass: SeamlessDefaultGarbageCollector
		andAuthenticationManager: ((SeamlessAuthenticationManager new)
										addGroup: 'default'
										withPolicy: (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Character . Number . String . Symbol . UndefinedObject}
														classesToPassByShallowCopy: {}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {SystemDictionary . OrderedCollection} asOrderedCollection  
																				classesNotToReference: {} asOrderedCollection
																				includingMessages: {SystemDictionary -> {#classNames} asOrderedCollection} asDictionary  
																				excludingMessages: {} asDictionary));
										addUser: 'default' withPassword: '' inGroup: 'default')
		shallowCopyEnabled: false.! !

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/17/2012 12:27'!
newWithTransporterClass: aTransporterClass transcoderClass: aTranscoderClass proxyClass: aProxyClass garbageCollectorClass: aGarbageCollectorClass andAuthenticationManager: anAuthenticationManager shallowCopyEnabled: aBoolean

	^ self new
		buildWithTransporterClass: aTransporterClass
		transcoderClass: aTranscoderClass 
		proxyClass: aProxyClass 
		garbageCollectorClass: aGarbageCollectorClass 
		andAuthenticationManager: anAuthenticationManager
		shallowCopyEnabled: aBoolean! !

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2012 12:02'!
newWithZincAndGlobalAccess

	^ self new
		buildWithTransporterClass: SeamlessZincTransporter 
		transcoderClass: SeamlessFuelTranscoder 
		proxyClass: SeamlessFastDNUProxy "SeamlessGhostProxy"
		garbageCollectorClass: SeamlessDefaultGarbageCollector
		andAuthenticationManager: ((SeamlessAuthenticationManager new)
										addGroup: 'default'
										withPolicy: (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Magnitude . String . Symbol . UndefinedObject . SeamlessOrderedCollection }
														classesToPassByShallowCopy: {}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {} asDictionary  
																				classesNotToReference: {} asDictionary
																				includingMessages: {} asDictionary  
																				excludingMessages: {} asDictionary));
										addUser: 'default' withPassword: '' inGroup: 'default')
		shallowCopyEnabled: false.! !

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2012 13:23'!
newWithZincShallowAndGlobalAccess

	^ self new
		buildWithTransporterClass: SeamlessZincTransporter 
		transcoderClass: SeamlessFuelTranscoder 
		proxyClass: SeamlessFastDNUProxy "SeamlessGhostProxy"
		garbageCollectorClass: SeamlessDefaultGarbageCollector
		andAuthenticationManager: ((SeamlessAuthenticationManager new)
										addGroup: 'default'
										withPolicy: (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Magnitude . String . Symbol . UndefinedObject . SeamlessOrderedCollection }
														classesToPassByShallowCopy: {OrderedCollection . Array}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {} asDictionary  
																				classesNotToReference: {} asDictionary
																				includingMessages: {} asDictionary  
																				excludingMessages: {} asDictionary));
										addUser: 'default' withPassword: '' inGroup: 'default')
		shallowCopyEnabled: true.! !

!SeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2012 18:48'!
newWithZodiacAndGlobalAccess

	^ self new
		buildWithTransporterClass: SeamlessZodiacTransporter 
		transcoderClass: SeamlessFuelTranscoder 
		proxyClass: SeamlessFastDNUProxy "SeamlessGhostProxy"
		garbageCollectorClass: SeamlessDefaultGarbageCollector
		andAuthenticationManager: ((SeamlessAuthenticationManager new)
										addGroup: 'default'
										withPolicy: (SeamlessDistributionPolicy newWithEntryPoint: Smalltalk globals
														classesToPassByValue: {Boolean . Magnitude . String . Symbol . UndefinedObject . SeamlessOrderedCollection}
														classesToPassByShallowCopy: {}
														andSecurityPolicy: (SeamlessSecurityPolicy newWithClassesToPassByReference: {} asDictionary  
																				classesNotToReference: {} asDictionary
																				includingMessages: {} asDictionary  
																				excludingMessages: {} asDictionary));
										addUser: 'default' withPassword: '' inGroup: 'default')
		shallowCopyEnabled: false.! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 10/23/2014 18:00'!
buildWithTransporterClass: aTransporterClass transcoderClass: aTranscoderClass proxyClass: aProxyClass garbageCollectorClass: aGarbageCollectorClass andAuthenticationManager: anAuthenticationManager shallowCopyEnabled: aBoolean


	shallowCopyFlag := aBoolean.
	objectTransporter := SeamlessObjectTransporter newWithTransporter: (aTransporterClass new) andTranscoder: (aTranscoderClass new).
	
	shallowCopyFlag ifFalse: [
	
		objectTransporter 
			onObjectReceivedEvaluate: [:conId :object |
				self packageReceived: object from: conId.	
			].

									
	] ifTrue: [
		
		objectTransporter 
			onObjectReceivedEvaluate: [:conId :object |
				self packageReceived: object from: conId.	
			] withPolicyCallback: [:conId |
				(sessions at: conId) policyCallback.
			].
		
	].

	objectTransporter onNewConnectionEvaluate: [:conId |
				sessions at: conId put: (SeamlessSession newHandledBy: self
										onConnection: (objectTransporter connectionInfoFor: conId)
										withDistributionStrategy: (SeamlessDistributionControl newWithProxyClass: aProxyClass
																	andGarbageCollector: aGarbageCollectorClass new)
										andAuthenticationManager: anAuthenticationManager)].! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 17:42'!
connectOn: aRemoteAddressAsString

	^ self connectOn: aRemoteAddressAsString withUsername: 'default' andPassword: ''.! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 17:41'!
connectOn: aRemoteAddressAsString withUsername: aUsername andPassword: aPassword

	|connectionId|
	
	connectionId := objectTransporter connectOn: aRemoteAddressAsString.
	
	^ (sessions at: connectionId) sendEntryPointRequestWithUsername: aUsername andPassword: aPassword.! !

!SeamlessDeamon methodsFor: 'accessing' stamp: 'NickPapoulias 11/2/2014 11:15'!
exceptionForwarding
	^ exceptionForwarding! !

!SeamlessDeamon methodsFor: 'accessing' stamp: 'NickPapoulias 11/2/2014 11:15'!
exceptionForwarding: anObject
	exceptionForwarding := anObject! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 11/2/2014 11:17'!
initialize 

	super initialize. 
	logging := false.
	exceptionForwarding := true.
	sessions := Dictionary new.! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 8/21/2012 12:42'!
logging: aBoolean

	sessions values do: [:s | s logging: aBoolean]! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 20:41'!
packageReceived: aPackage from: aSeamlessConnectionId
	
	(sessions at: aSeamlessConnectionId) receivedPackage: aPackage 
	
	! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 8/8/2012 12:27'!
sendPackage: aPackage through: aSeamlessConnectionId

	shallowCopyFlag ifFalse: [

		[objectTransporter send: aPackage through: aSeamlessConnectionId] fork.
		
	] ifTrue: [
	
		[objectTransporter send: aPackage through: aSeamlessConnectionId withPolicyCallback: (sessions at: aSeamlessConnectionId) policyCallback] fork.
		
	] ! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 17:06'!
serverAddress 

	^ objectTransporter serverAddress 
	! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 17:04'!
start

	objectTransporter start! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 17:04'!
startOn: anIdentifier 

	objectTransporter startOn: anIdentifier! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 8/20/2012 12:15'!
stop

	[objectTransporter stop] on: Exception do: [] "catch all -- for safe clenaup -- refactor"! !

!SeamlessDeamon methodsFor: 'seamless-package-handling' stamp: 'NickPapoulias 6/2/2012 18:24'!
stop: aSeamlessConnectionId

	objectTransporter stop: aSeamlessConnectionId.
	sessions removeKey: aSeamlessConnectionId.! !

Object subclass: #SeamlessDeamonManager
	instanceVariableNames: 'defaultDeamon entryPointDict deamons'
	classVariableNames: 'default'
	poolDictionaries: ''
	category: 'Seamless-Deamon'!

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 18:54'!
addDefaultGlobalAccessDeamonOnPort: aPortNumber

	^ self defaultDeamon: (self addGlobalAccessDeamonOnPort: aPortNumber)


! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 17:33'!
addGlobalAccessDeamonOnPort: aPortNumber

	^ self default deamons add: (SeamlessDeamon newDefaultWithGlobalAccess startOn: aPortNumber).! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/21/2012 12:47'!
default

	^ default ifNil: [ default := self basicNew initialize ]! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 18:54'!
defaultDeamon: aDeamon

	^ self default defaultDeamon: aDeamon! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 12:06'!
initialize

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 12:02'!
new

	^ self default! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 12:38'!
shutDown: quitting

	self default shutDown! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 12:38'!
startUp: resuming

	self default startUp! !

!SeamlessDeamonManager class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 18:09'!
stop: aDeamon

	aDeamon stop.
	self default defaultDeamon = aDeamon ifTrue: [ self default defaultDeamon: nil ].! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:24'!
address

	^ defaultDeamon serverAddress , ':' , self defaultPort ! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 17:25'!
addressAsRemoteEnvironment: aRemoteAddressAsString

	^ entryPointDict at: aRemoteAddressAsString ifAbsent: [
		entryPointDict at: aRemoteAddressAsString put: (self defaultDeamon connectOn: aRemoteAddressAsString).	
	]! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 17:32'!
cleanUp

	defaultDeamon ifNotNil: [ defaultDeamon stop ].
	
	SeamlessProcessManager allInstances do: [:p | p terminateAll ].
	
	SeamlessSocketStreamTransporter allInstances do: [:t | t stop].
	
	Socket allInstances do: [:s | s destroy].
	
	defaultDeamon := nil.
	
	deamons := OrderedCollection new.
	
	entryPointDict := Dictionary new.! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 17:24'!
deamons

	^ deamons! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 17:26'!
defaultDeamon

	^ defaultDeamon ifNil: [ defaultDeamon := SeamlessDeamon newDefaultWithGlobalAccess startOn: self defaultPort. ]! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/30/2013 18:54'!
defaultDeamon: aDeamon

	^ defaultDeamon := aDeamon! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/25/2012 00:15'!
defaultPort

	^ 8080! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 11:16'!
initialize

	deamons := OrderedCollection new.
	
	entryPointDict := Dictionary new.
	
	Smalltalk vm maxExternalSemaphoresSilently: 65535.! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/21/2012 12:52'!
logging: aBoolean

	defaultDeamon logging: aBoolean! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 12:32'!
shutDown

	self cleanUp! !

!SeamlessDeamonManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/20/2012 12:31'!
startUp

	self cleanUp.
	self initialize.! !

Object subclass: #SeamlessDefaultGarbageCollector
	instanceVariableNames: 'distributionTable gcProcess gcCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Garbage-Collector'!

!SeamlessDefaultGarbageCollector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:35'!
gc: proxiedObjectsToUnreference 

	distributionTable unreferenceProxiedObjectsWithIds: proxiedObjectsToUnreference! !

!SeamlessDefaultGarbageCollector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 10:18'!
gcOnTable: aDistributionTable

	distributionTable := aDistributionTable ! !

!SeamlessDefaultGarbageCollector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:35'!
onGcEvaluate: aBlock

	gcCallback := aBlock! !

!SeamlessDefaultGarbageCollector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:39'!
start

	gcProcess := [
	
		[
			|unreferencedProxies|
			(Delay forSeconds: 2) wait.
			unreferencedProxies := distributionTable unreferencedProxies.
			unreferencedProxies ifNotNil: [
				gcCallback value: unreferencedProxies.		
			]
		] repeat.	
			
	] fork.! !

!SeamlessDefaultGarbageCollector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:39'!
stop

	gcProcess terminate.! !

Object subclass: #SeamlessDistributionControl
	instanceVariableNames: 'session proxyClass proxyHandler garbageCollector distributionPolicy processManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Control'!

!SeamlessDistributionControl class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 11:25'!
newWithProxyClass: aProxyClass andGarbageCollector: aGarbageCollector

	^ self new
		initializeWithProxyClass: aProxyClass andGarbageCollector: aGarbageCollector! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 14:33'!
distributionPolicy: aDistributionPolicy

	distributionPolicy := aDistributionPolicy.
	distributionPolicy session: session.
	proxyHandler session: session.
	distributionPolicy proxyClass: proxyClass.
	distributionPolicy proxyHandler: proxyHandler.
	garbageCollector gcOnTable:  distributionPolicy distributionTable.
	self start.! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 12:02'!
entryPoint

	^ distributionPolicy entryPoint! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:34'!
garbageCollectUpdate: proxiedObjectsToUnreference

	garbageCollector gc: proxiedObjectsToUnreference.! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 18:37'!
initializeWithProxyClass: aProxyClass andGarbageCollector: aGarbageCollector

	proxyClass := aProxyClass.
	proxyHandler := proxyClass defaultHandlerClass new.
	
	proxyHandler onMessageInterceptEvaluate: [:process :aProxy :selector :args |
		self messageInterceptedFromProcess: process proxiedBy: aProxy withSelector: selector andArgs: args.
	].

	"distributionPolicy := aDistributionPolicy.
	distributionPolicy session: session.
	distributionPolicy proxyClass: aProxyClass.
	distributionPolicy proxyHandler: proxyHandler."
	garbageCollector := aGarbageCollector 
		onGcEvaluate: [:unreferencedProxies |
			session sendPackage: (SeamlessGcUpdate new proxiedObjectsToUnreference: unreferencedProxies).
		].! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 10:55'!
messageInterceptedFromProcess: process proxiedBy: aProxy withSelector: selector andArgs: args

	|localProcessId request wrapper arguments returnValue|

	localProcessId := processManager add: process. "this is actually the active process -- should refactor"
	
	"Transcript show: 'intercepted '; show: selector asString; cr."
	
	wrapper := (distributionPolicy wrapperForProxy: aProxy).

	"Transcript show: 'wrapped receiver'; cr."
	
	arguments := (distributionPolicy wrappersForArgs: args).
	
	"Transcript show: 'wrapped arguments'; cr."	 

	request := (SeamlessMessageSendRequest new
									initializeWithReceiver: wrapper  
									selector: selector  
									arguments: arguments 
									processId: localProcessId). 
	
	"Transcript show: 'Prepared request'."
	
	session sendPackage: request. 
									
	"Transcript show: 'sended package'."
	
	processManager suspend: localProcessId.
	"the process is suspended until the other end responds with the return value"
	(processManager exceptionFor: localProcessId) ifNotNilDo: [:exDescription | Exception signal: exDescription].
	returnValue := processManager returnValueFor: localProcessId.
	
	"returnValue xxx___isProxy ifTrue:[
		Transcript show: '(in strategy) returned value (proxy): '; show: returnValue xxx___remoteObjectId; show: 'to processId: '; show: localProcessId; cr.
	]."
	
	^ returnValue ! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2012 10:13'!
policy
	
	^ distributionPolicy ! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 11:56'!
processManager: aProcessManager

	processManager := aProcessManager ! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 13:44'!
proxyHandler

	^ proxyHandler! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 18:56'!
session: aSession

	session := aSession.! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 13:12'!
start

	"garbageCollector start."! !

!SeamlessDistributionControl methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:48'!
stop
	
	garbageCollector stop.! !

Object subclass: #SeamlessDistributionPolicy
	instanceVariableNames: 'session distributionTable classesToPassByValue classesToPassByShallowCopy securityPolicy entryPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Policy'!

!SeamlessDistributionPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 12:11'!
newWithEntryPoint: anObject classesToPassByValue: classesToPassByValueCollection classesToPassByShallowCopy: classesToPassByShallowCopyCollection  andSecurityPolicy: aSecurityPolicy

	^ self new
		initializeWithEntryPoint: anObject classesToPassByValue: classesToPassByValueCollection classesToPassByShallowCopy: classesToPassByShallowCopyCollection  andSecurityPolicy: aSecurityPolicy! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:54'!
cleanCopy

	^ self class newWithEntryPoint: entryPoint classesToPassByValue: classesToPassByValue classesToPassByShallowCopy: classesToPassByShallowCopy andSecurityPolicy: securityPolicy ! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 11:16'!
distributionTable 

	^ distributionTable ! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 12:07'!
entryPoint

	^ self wrapperForObjectToBeProxied: entryPoint. "this will also check against the security restrictions"! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2012 11:19'!
initializeWithEntryPoint: anObject classesToPassByValue: classesToPassByValueCollection classesToPassByShallowCopy: classesToPassByShallowCopyCollection andSecurityPolicy: aSecurityPolicy

	entryPoint := anObject.

	classesToPassByValue := Set new.
	classesToPassByValueCollection do: [:aClass |
		classesToPassByValue add: aClass.
		classesToPassByValue addAll: aClass allSubclasses.
	].

	"classesToPassByShallowCopy := Set new.
	classesToPassByShallowCopyCollection do: [:aClass |
			classesToPassByShallowCopy add: aClass.
			classesToPassByShallowCopy addAll: aClass allSubclasses.
	].
"
	"Since classes to pass by shallow copy are critical do not automatically include subclasses"
	classesToPassByShallowCopy := classesToPassByShallowCopyCollection.
	securityPolicy := aSecurityPolicy.
	distributionTable := SeamlessFasterDistributionTable new.! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/19/2012 15:34'!
policyCallback

	^ [:object :mode |
		
		(mode = #serialize) ifTrue: [
			
				object xxx___isProxy ifTrue: [ "is it a proxy ?"
					self wrapperForProxy: object.
				] ifFalse: [
					(classesToPassByValue includes: object class) ifTrue: [ "should it be passed by value ?"
						object
					] ifFalse: [ "shallow"
						(classesToPassByShallowCopy includes: object class) ifTrue: [
							object	
						] ifFalse: [ "or by reference (proxy)"
							self wrapperForObjectToBeProxied: object.
						]
					]
				]
			
		]
		ifFalse: [
		
			(mode = #materializeFromWrapper) ifTrue: [
		
				object resolveWith: self.
		
			] ifFalse: [
			
				self error: 'wrong policy callback mode'.
					
			].
			
		]
	
	]
	! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 11:11'!
proxyClass: aProxyClass

	distributionTable proxyClass: aProxyClass.! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 11:14'!
proxyHandler: aProxyHandler

	distributionTable proxyHandler: aProxyHandler.! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 11:07'!
resolveCreateNewProxyWrapperWithRemoteId: remoteObjectId

	^ distributionTable addNewProxyWithId: remoteObjectId 

	! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 16:50'!
resolveCreateNewProxyWrapperWithRemoteId: remoteObjectId forAnotherSessionWithInfo: sessionInfo! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 10:41'!
resolveRestoreProxiedObjectWrapper: aRestoreProxiedObjectWrapper

! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 16:53'!
resolveRestoreProxiedObjectWrapperWithLocalObjectId: localObjectId

	^ distributionTable proxiedObjectAt: localObjectId 
! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 16:55'!
resolveSerializedObjectWrapper: aSerializedObjectWrapper

	"new feature: check if this object should have been materialized"
	
	^ aSerializedObjectWrapper serializedObject
! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 14:38'!
securityPolicy

	^ securityPolicy
! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 16:12'!
session: aSeamlessSession 

	session := aSeamlessSession ! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 22:24'!
wrapperForObject: anObject

		(anObject class = SerializedObjectWrapper) ifTrue: [ ^ anObject ]. "forced by value: construct"

		anObject xxx___isProxy ifTrue: [ "is it a proxy ?"
			^ self wrapperForProxy: anObject.
		] ifFalse: [
			(classesToPassByValue includes: anObject class) ifTrue: [ "should it be passed by value ?"
				^ self wrapperForSerializedObject: anObject.
			] ifFalse: [ "or by reference (proxy)"
				(classesToPassByShallowCopy includes: anObject class) ifTrue: [
					^ self wrapperForShallowSerializedObject: anObject.	
				] ifFalse: [
					^ self wrapperForObjectToBeProxied: anObject.
				]
			]
		]! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 11:38'!
wrapperForObjectToBeProxied: anObject

	securityPolicy checkObjectToBeProxied: anObject. "will raise an error if there is a security restriction"
	
	^ CreateNewProxyWrapper new remoteObjectId: (distributionTable addProxiedObject: anObject).! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 21:06'!
wrapperForProxy: aProxy
	"Transcript show: 'wrapping proxy'; cr."
	aProxy xxx___handler session = session ifTrue: [ "is it a proxy for this session ?"
		^ RestoreProxiedObjectWrapper new localObjectId: (aProxy xxx___remoteObjectId).
	] ifFalse: [ "it is a proxy for another session -- this is the strategy where there would be a direct new proxy"
		^ CreateNewProxyForAnotherSessionWrapper new 
					remoteObjectId: (aProxy xxx___remoteObjectId);
					sessionInfo: (aProxy xxx___handler session sessionInfo);
					yourself.
	]! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 10:47'!
wrapperForSerializedObject: anObject

	^ SerializedObjectWrapper new serializedObject: anObject.! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 12:17'!
wrapperForShallowSerializedObject: anObject

	^ ShallowSerializedObjectWrapper new serializedObject: anObject.! !

!SeamlessDistributionPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 11:49'!
wrappersForArgs: args


	^ args collect: [:arg |
		
		self wrapperForObject: arg
	
	]! !

Object subclass: #SeamlessDistributionTable
	instanceVariableNames: 'proxiedObjects proxies proxyClass proxyHandler proxiedObjectsNextId proxiesSemaphore proxiedObjectsSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Table'!

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 21:04'!
addNewProxyWithId: aRemoteObjectId

	proxiesSemaphore critical: [
		(proxies keys includes: aRemoteObjectId) ifFalse: [
			|proxy|
			proxy := proxyClass new.
			proxy xxx___handler: proxyHandler.
			proxy xxx___remoteObjectId: aRemoteObjectId. 
			proxies at: aRemoteObjectId put: proxy
		].
		"Transcript show: 'adding proxy: '; show: aRemoteObjectId; cr."
		^ proxies at: aRemoteObjectId
	].! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/31/2012 15:05'!
addProxiedObject: anObject

	"should return an id"
	| objectId |
	
	proxiedObjectsSemaphore critical: [
		(proxiedObjects includes: anObject) ifTrue: [
			^ proxiedObjects keyAtValue: anObject.
		].
	
		objectId := self proxiedObjectsNextId.
		proxiedObjects at: objectId put: anObject.
		^ objectId
	].! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/8/2012 12:55'!
initialize

	super initialize.
	proxiedObjects := Dictionary new.
	proxies := Dictionary new."WeakValueDictionary new."
	proxiedObjectsNextId := 0. 
	proxiesSemaphore := Semaphore forMutualExclusion.
	proxiedObjectsSemaphore := Semaphore forMutualExclusion.! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:05'!
proxiedObjectAt: proxiedObjectId

	proxiedObjectsSemaphore critical: [
		^ proxiedObjects at: proxiedObjectId
	]. ! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 21:06'!
proxiedObjectsNextId 

		proxiedObjectsNextId := proxiedObjectsNextId + 1.
		^ proxiedObjectsNextId.! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 12:47'!
proxyClass: aProxyClass

	proxyClass := aProxyClass! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 11:16'!
proxyHandler: aProxyHandler

	proxyHandler := aProxyHandler! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:16'!
unreferenceProxiedObjectsWithIds: proxiedObjectsIds

	proxiedObjectsSemaphore critical: [
		proxiedObjectsIds do: [:key |
			proxiedObjects removeKey: key.
		].
	].! !

!SeamlessDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 14:14'!
unreferencedProxies

	|unreferencedProxies|

	proxiesSemaphore critical: [
		unreferencedProxies := (proxies select: [:value | value = nil ]) keys.
		unreferencedProxies do: [:key |
			proxies removeKey: key.
		].
		^ unreferencedProxies.
	]! !

SeamlessDistributionTable subclass: #SeamlessFasterDistributionTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Distribution-Table'!

!SeamlessFasterDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/8/2012 13:44'!
addNewProxyWithId: aRemoteObjectId


	^ proxies at: aRemoteObjectId ifAbsent: [
			proxies at: aRemoteObjectId put: (proxyClass new
							xxx___handler: proxyHandler;
							xxx___remoteObjectId: aRemoteObjectId).
	]! !

!SeamlessFasterDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/30/2012 12:48'!
addProxiedObject: anObject

	"should return an id"
	| objectId |
	
	(proxiedObjects includes: anObject) ifTrue: [
			^ proxiedObjects keyAtValue: anObject.
	].
	
	objectId := self proxiedObjectsNextId.
	proxiedObjects at: objectId put: anObject.
	^ objectId! !

!SeamlessFasterDistributionTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/8/2012 13:46'!
proxiedObjectAt: proxiedObjectId

	^ proxiedObjects at: proxiedObjectId! !

Object subclass: #SeamlessExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!SeamlessExample commentStamp: 'NickPapoulias 10/25/2014 12:03' prior: 0!
This is an abstract superclass for the examples
to distinguish them from helper classes..

Defines the method run which should be implemented in subclasses!

SeamlessExample subclass: #ContactsDatabaseExample
	instanceVariableNames: ''
	classVariableNames: 'dbBackUp localBlock localDeamon remoteBlock remoteEnvironment remotePingPongClass remoteTranscript'
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!ContactsDatabaseExample commentStamp: 'NickPapoulias 10/25/2014 12:01' prior: 0!
http://www.pharocasts.com/2011/02/pharo-gui-with-polymorph.html

This is a local application from pharocasts that goes distributed with
seamless -- check it independently here:

Gofer it
 squeaksource: 'Pharocasts';
 package: 'ContactManager';
 load.

For the example run:

self localContactEditor
self remoteContactEditor
self dataBalancingContactEditor

Note: write some example entries for both sides!

!ContactsDatabaseExample class methodsFor: 'contact-manager' stamp: 'NickPapoulias 8/21/2012 15:30'!
dataBalancingContactEditor

	"self dataBalancingContactEditor"

	dbBackUp := Contact database.
	
	Contact database: (OrderedCollection new 
							addAll: dbBackUp; 
							addAll: (Contact from: '127.0.0.1:8081') database;
							yourself).

	ContactListEditor open.
	
	"Contact database: dbBackUp"
	
	
	
	
	
! !

!ContactsDatabaseExample class methodsFor: 'contact-manager' stamp: 'NickPapoulias 8/20/2012 17:39'!
localContactEditor

	"self localContactEditor"

	ContactListEditor open.
	
	
	
! !

!ContactsDatabaseExample class methodsFor: 'logging' stamp: 'NickPapoulias 8/21/2012 13:37'!
logging: aBoolean

	"self logging: true"
	"self logging: false"

	SeamlessDeamonManager default logging: aBoolean.
	(SeamlessDeamonManager from: '127.0.0.1:8081') default logging: aBoolean.
	
	
	
! !

!ContactsDatabaseExample class methodsFor: 'contact-manager' stamp: 'NickPapoulias 8/20/2012 18:55'!
remoteContactEditor

	"self remoteContactEditor"

	dbBackUp := Contact database.
	
	Contact database: (Contact from: '127.0.0.1:8081') database.

	ContactListEditor open.
	
	"Contact database: dbBackUp"
	
	
	
	
	
! !

SeamlessExample subclass: #ExceptionForwardingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!ExceptionForwardingExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/24/2014 14:57'!
raiseExceptionAfter: aCounter using: remoteInstance

	aCounter = 0 
		ifTrue: [ Error new signal ]
		ifFalse: [ remoteInstance 
					raiseExceptionAfter: aCounter - 1
					using: self]! !

SeamlessExample subclass: #GameExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

SeamlessExample subclass: #PharoUIThreadingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!SeamlessExample class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/1/2014 15:52'!
logging: aBoolean

	"self logging: true"
	"self logging: false"
	
	"close all open transcripts - and open a new one on each side"

	SeamlessDeamonManager default logging: aBoolean.
	(SeamlessDeamonManager from: '127.0.0.1:8081') default logging: aBoolean.! !

!SeamlessExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/25/2014 12:02'!
run

	self subclassResponsibility ! !

SeamlessExample subclass: #SeamlessLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Logging'!

SeamlessExample subclass: #TestRunnerExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Examples'!

TestRunnerExample class
	instanceVariableNames: 'packageNamesToSuitesDict'!

TestRunnerExample class
	instanceVariableNames: 'packageNamesToSuitesDict'!

!TestRunnerExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/1/2014 15:49'!
testCategoryNamed: aCategoryName at: aRemoteAddress

	"[TestRunnerExample new
		testCategoryNamed: #'ProfStef-Tests'
		at: '127.0.0.1:8081'] fork
	"

	| tr |
	tr := (TestRunner from: aRemoteAddress) new.

	tr
		categoryAt: (tr categoryList indexOf: aCategoryName) put: true; 
		selectAllClasses;
		runAll.
	
	"difference on inspection between local and remote objects"
	tr result inspect.
	tr result asLocalObject inspect.
	Smalltalk tools inspector inspect: tr result.! !

SeamlessExample subclass: #TutorialExample
	instanceVariableNames: ''
	classVariableNames: 'localBlock localDeamon remoteBlock remoteEnvironment remotePingPongClass remoteTranscript'
	poolDictionaries: ''
	category: 'Seamless-Examples'!

!TutorialExample class methodsFor: 'ping-pong' stamp: 'NickPapoulias 8/23/2012 21:01'!
insaneLocalPingPong

	"self insaneLocalPingPong"

	PingPong new decrement: 10 using: PingPong new and: [:x | x - 1]. 
	
	"[PingPong new decrement: 10 using: remotePingPongClass new and: [:x | x - 1]] fork"! !

!TutorialExample class methodsFor: 'ping-pong' stamp: 'NickPapoulias 8/23/2012 21:01'!
insanePingPong

	"self insanePingPong"

	remotePingPongClass := PingPong from: '127.0.0.1:8081'. 

	PingPong new decrement: 10 using: remotePingPongClass new and: [:x | x - 1]. 
	
	"[PingPong new decrement: 10 using: remotePingPongClass new and: [:x | x - 1]] fork."! !

!TutorialExample class methodsFor: 'ping-pong' stamp: 'NickPapoulias 8/23/2012 19:17'!
localPingPong

	"self localPingPong"

	PingPong new decrement: 100 using: PingPong new.! !

!TutorialExample class methodsFor: 'logging' stamp: 'NickPapoulias 8/23/2012 19:17'!
logging: aBoolean

	"self logging: true"
	"self logging: false"

	SeamlessDeamonManager default logging: aBoolean.
	(SeamlessDeamonManager from: '127.0.0.1:8081') default logging: aBoolean.
	
	
	
! !

!TutorialExample class methodsFor: 'ping-pong' stamp: 'NickPapoulias 8/23/2012 19:24'!
pingPong

	"self pingPong"

	remotePingPongClass := ('127.0.0.1:8081' globalAt: #PingPong). 

	PingPong new decrement: 100 using: remotePingPongClass new. 
	
	"[PingPong new decrement: 100 using: remotePingPongClass new] fork"! !

!TutorialExample class methodsFor: 'transcript' stamp: 'NickPapoulias 8/23/2012 19:18'!
transcript

	"self transcript"

	(1 to: 100) do: [:i | 
		(Transcript from: '127.0.0.1:8081') show: i; cr.
	].	
	
	
	
	
! !

!TutorialExample class methodsFor: 'transcript' stamp: 'NickPapoulias 8/23/2012 19:17'!
transcriptSugar1

	"self transcriptSugar1"

	remoteTranscript := '127.0.0.1:8081' globalAt: #Transcript.

	(1 to: 100) do: [:i | 
		remoteTranscript show: i; cr.
	].	
	
	
	
	
! !

!TutorialExample class methodsFor: 'transcript' stamp: 'NickPapoulias 8/23/2012 19:17'!
transcriptSugar2

	"self transcriptSugar2"
	
	remoteEnvironment := '127.0.0.1:8081' asRemoteEnvironment.

	remoteTranscript := remoteEnvironment at: #Transcript.

	(1 to: 100) do: [:i | 
		remoteTranscript show: i; cr.
	].	
	
	
	
	
! !

!TutorialExample class methodsFor: 'transcript' stamp: 'NickPapoulias 8/23/2012 19:20'!
transcriptSugar3

	"self transcriptSugar3"

	remoteTranscript := (Smalltalk from: '127.0.0.1:8081') globals at: #Transcript.

	(1 to: 100) do: [:i | 
		remoteTranscript show: i; cr.
	].	
	
	
	
	
	
! !

Object subclass: #SeamlessFastDNUProxy
	uses: TSeamlessRemoteProxy
	instanceVariableNames: 'handler remoteObjectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

SeamlessFastDNUProxy class
	uses: TSeamlessRemoteProxy classTrait
	instanceVariableNames: 'FastDNUClass'!

SeamlessFastDNUProxy class
	uses: TSeamlessRemoteProxy classTrait
	instanceVariableNames: 'FastDNUClass'!

!SeamlessFastDNUProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2012 11:15'!
defaultHandlerClass

	^ SeamlessFastDNUProxyHandler! !

!SeamlessFastDNUProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:56'!
initialize

	super initialize. 
	FastDNUClass := Behavior new.
	FastDNUClass setFormat: self format.
	FastDNUClass methodDict: methodDict. "since this is not a deep copy the two classes are in sync ?"
	FastDNUClass superclass: nil.
	! !

!SeamlessFastDNUProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 18:19'!
new
	
	| newInstance |
	
	FastDNUClass setFormat: self format. "update format if it has changed"
	newInstance := self basicNew initialize.
	FastDNUClass adoptInstance: newInstance.
	^ newInstance! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/6/2012 18:01'!
doesNotUnderstand: aMessage

	"Transcript show: aMessage asString."

	^ self xxx___messageIntercepted: aMessage.! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/23/2012 21:58'!
inspectorClass

	^ Smalltalk tools inspector! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:16'!
xxx___handler

	^ handler! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:16'!
xxx___handler: aHandler

	handler := aHandler! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 20:43'!
xxx___messageIntercepted: aMessage

		^ self xxx___handler messageInterceptedInProcess: (Processor activeProcess) by: self withSelector: aMessage selector andArguments: aMessage arguments. ! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:21'!
xxx___remoteObjectId

	^ remoteObjectId! !

!SeamlessFastDNUProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:21'!
xxx___remoteObjectId: aRemoteObjectId

	remoteObjectId := aRemoteObjectId ! !

Object subclass: #SeamlessFastDNUProxyHandler
	uses: TSeamlessRemoteProxyHandler
	instanceVariableNames: 'messageInterceptCallback session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

SeamlessFastDNUProxyHandler class
	uses: TSeamlessRemoteProxyHandler classTrait
	instanceVariableNames: ''!

!SeamlessFastDNUProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:15'!
messageInterceptCallback

	^ messageInterceptCallback ! !

!SeamlessFastDNUProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 17:15'!
messageInterceptCallback: aBlock

	messageInterceptCallback := aBlock! !

!SeamlessFastDNUProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 20:44'!
messageInterceptedInProcess: aProcess by: aProxy withSelector: aSelector andArguments: args 

	self messageInterceptCallback ifNotNil: [
		^ self messageInterceptCallback value: aProcess value: aProxy value: aSelector value: args
	]! !

!SeamlessFastDNUProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 15:46'!
session

	^ session! !

!SeamlessFastDNUProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 15:47'!
session: aSeamlessSession 

	session := aSeamlessSession ! !

Object subclass: #SeamlessObjectTransporter
	instanceVariableNames: 'transporter transcoder objectReceivedCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Object-Transporter'!

!SeamlessObjectTransporter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 15:27'!
newWithTransporter: aTransporter andTranscoder: aTranscoder

	^ self new 
		withTranscoder: aTranscoder;
		withTransporter: aTransporter.! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 18:59'!
connectOn: aRemoteAddressAsString

	^ transporter connectOn: aRemoteAddressAsString 

	! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:37'!
connectionIds 

	^ transporter connectionIds ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 19:01'!
connectionInfoFor: aConnectionId

	^ transporter connectionInfoFor: aConnectionId 

	! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:29'!
onNewConnectionEvaluate: aBlock

	transporter onNewConnectionEvaluate: aBlock! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:17'!
onObjectReceivedEvaluate: aBlock

	"mind the string/bytearray dif"

	transporter onDataReceivedEvaluate: [:connectId :data |
		aBlock value: connectId value: (transcoder materialize: data).	
	]! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:16'!
onObjectReceivedEvaluate: aBlock withPolicyCallback: aPolicyCallback 

	"mind the string/bytearray dif"

	transporter onDataReceivedEvaluate: [:connectId :data |
		aBlock value: connectId value: (transcoder materialize: data usingCallback: (aPolicyCallback value: connectId)).	
	]! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:29'!
onStoppedEvaluate: aBlock

	transporter onStoppedEvaluate: aBlock! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:30'!
onTransportingErrorEvaluate: aBlock

	transporter onTransportingErrorEvaluate: aBlock! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/17/2012 12:19'!
send: anObject through: aSeamlessConnectionId

	transporter send: (transcoder serialize: anObject) through: aSeamlessConnectionId. ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/18/2012 13:14'!
send: anObject through: aSeamlessConnectionId withPolicyCallback: aPolicyCallback

	
	transporter send: (transcoder serialize: anObject usingCallback: aPolicyCallback) through: aSeamlessConnectionId. ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:43'!
serverAddress 

	^ transporter serverAddress 
	! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:43'!
start

	transporter start! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:44'!
startOn: anIdentifier

	transporter startOn: anIdentifier ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:45'!
stop

	transporter stop! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:50'!
stop: aSeamlessConnectionId

	transporter stop: aSeamlessConnectionId ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/17/2012 12:14'!
withTranscoder: aTranscoder

	transcoder := aTranscoder.! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:36'!
withTransporter: aTransporter

	transporter := aTransporter ! !

Object subclass: #SeamlessPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessPackage methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/15/2012 16:19'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

SeamlessPackage subclass: #SeamlessRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

SeamlessRequest subclass: #SeamlessEntryPointRequest
	instanceVariableNames: 'remoteConnectionId seamlessUserCredentials remoteProcessId localServerAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessEntryPointRequest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 18:56'!
handleWith: aSeamlessSession

	"double dispatch hook"

	aSeamlessSession entryPointRequestWithCredentials: seamlessUserCredentials withRemoteConnectionId: remoteConnectionId forRemoteProcess: remoteProcessId inRemoteServer: localServerAddress.! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:55'!
localServerAddress

	^ localServerAddress! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:55'!
localServerAddress: anAddress

	localServerAddress := anAddress! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:04'!
remoteConnectionId
	^ remoteConnectionId! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:04'!
remoteConnectionId: anObject
	remoteConnectionId := anObject! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:04'!
remoteProcessId
	^ remoteProcessId! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:04'!
remoteProcessId: anObject
	remoteProcessId := anObject! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:04'!
seamlessUserCredentials
	^ seamlessUserCredentials! !

!SeamlessEntryPointRequest methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:04'!
seamlessUserCredentials: anObject
	seamlessUserCredentials := anObject! !

SeamlessRequest subclass: #SeamlessMessageSendRequest
	instanceVariableNames: 'selector remoteProcessId receiverWrapper argumentWrappersAsArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessMessageSendRequest class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 11:01'!
newWithReceiver: remoteReceiverWrapper selector: aSelector arguments: argumentsAsArray processId: aLocalProcessId

	^ self new
		initializeWithReceiver: remoteReceiverWrapper selector: aSelector arguments: argumentsAsArray processId: aLocalProcessId! !

!SeamlessMessageSendRequest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 09:55'!
handleWith: aSeamlessSession

	"double dispatch hook"

	aSeamlessSession messageSendRequestWithReceiver: receiverWrapper selector: selector arguments: argumentWrappersAsArray forRemoteProcessId: remoteProcessId.! !

!SeamlessMessageSendRequest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 11:01'!
initializeWithReceiver: remoteReceiverWrapper selector: aSelector arguments: argumentsAsArray processId: aLocalProcessId

	receiverWrapper := remoteReceiverWrapper.
	selector := aSelector.
	argumentWrappersAsArray := argumentsAsArray.
	remoteProcessId := aLocalProcessId.! !

!SeamlessRequest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2012 15:29'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

SeamlessPackage subclass: #SeamlessResponce
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

SeamlessResponce subclass: #SeamlessEntryPointResponce
	instanceVariableNames: 'remoteConnectionId localProcessId entryPointWrapper remoteServerAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 5/31/2012 04:50'!
entryPoint
	^ entryPointWrapper! !

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 5/31/2012 04:50'!
entryPoint: anObject
	entryPointWrapper := anObject! !

!SeamlessEntryPointResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/24/2012 19:00'!
handleWith: aSeamlessSession

	"double dispatch hook"

	aSeamlessSession entryPointResponceWithEntryPoint: entryPointWrapper withRemoteConnectionId: remoteConnectionId forLocalProcessId: localProcessId fromRemoteServer: remoteServerAddress.! !

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2012 14:35'!
localProcessId
	^ localProcessId! !

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2012 14:35'!
localProcessId: anObject
	localProcessId := anObject! !

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2012 14:35'!
remoteConnectionId
	^ remoteConnectionId! !

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2012 14:35'!
remoteConnectionId: anObject
	remoteConnectionId := anObject! !

!SeamlessEntryPointResponce methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 19:00'!
remoteServerAddress: anAddress

	remoteServerAddress := anAddress! !

SeamlessResponce subclass: #SeamlessExceptionResponce
	instanceVariableNames: 'exceptionString exceptionWrapper localProcessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessExceptionResponce class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 10:33'!
newForException: ex andMessage: aMessage forProcessId: aLocalProcessId

	^ self new
		initializeWithMessageText: aMessage 
		exception: ex 
		for: aLocalProcessId
		! !

!SeamlessExceptionResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 09:57'!
handleWith: aSeamlessSession

	"double dispatch hook"

	aSeamlessSession exceptionResponceWithMessage: exceptionString andOptionalRemoteException: exceptionWrapper forProcess: localProcessId ! !

!SeamlessExceptionResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/25/2012 00:49'!
initializeWithMessageText: anExceptionString exception: anExceptionWrapper for: alocalProcessId

	exceptionString := anExceptionString.
	exceptionWrapper := anExceptionWrapper.
	localProcessId := alocalProcessId.! !

!SeamlessResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2012 15:29'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

SeamlessResponce subclass: #SeamlessReturnValueResponce
	instanceVariableNames: 'returnValueWrapper processId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessReturnValueResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 09:57'!
handleWith: aSeamlessSession

	"double dispatch hook"

	aSeamlessSession returnValueResponce: returnValueWrapper forProcess: processId! !

!SeamlessReturnValueResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 14:56'!
remoteProcessId: aRemoteProcessId

	processId := aRemoteProcessId ! !

!SeamlessReturnValueResponce methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 14:56'!
returnValue: aReturnValueWrapper

	returnValueWrapper := aReturnValueWrapper ! !

SeamlessPackage subclass: #SeamlessSystemPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

SeamlessSystemPackage subclass: #SeamlessBenchmarking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Benchmarking'!

SeamlessSystemPackage subclass: #SeamlessGcUpdate
	instanceVariableNames: 'proxiedObjectsToUnreference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessGcUpdate methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/18/2012 13:04'!
handleWith: aSeamlessSession

	"double dispatch hook"

	aSeamlessSession garbageCollectionUpdateWithProxiedObjectsToUnrefence: proxiedObjectsToUnreference ! !

!SeamlessGcUpdate methodsFor: 'accessing' stamp: 'NickPapoulias 6/1/2012 14:31'!
proxiedObjectsToUnreference
	^ proxiedObjectsToUnreference! !

!SeamlessGcUpdate methodsFor: 'accessing' stamp: 'NickPapoulias 6/1/2012 14:31'!
proxiedObjectsToUnreference: anObject
	proxiedObjectsToUnreference := anObject! !

SeamlessSystemPackage subclass: #SeamlessPauseSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessPauseSession methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2012 15:30'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

SeamlessSystemPackage subclass: #SeamlessResumeSession
	instanceVariableNames: 'aPreviousSessionInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessResumeSession methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2012 15:30'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

SeamlessSystemPackage subclass: #SeamlessStopSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Protocol-Packets'!

!SeamlessStopSession methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2012 15:30'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

!SeamlessSystemPackage methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2012 15:29'!
handleWith: aSeamlessSession

	"double dispatch hook"

	self subclassResponsibility ! !

Object subclass: #SeamlessProcessManager
	instanceVariableNames: 'nextId processDict returnValuesDict exceptionsDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Process-Manager'!

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 12:19'!
add: aProcess

	|id|
	
	id := self nextId.
	processDict at: id put: aProcess.
	^ id! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 10:51'!
exceptionFor: aProcessId
	
	^ exceptionsDict at: aProcessId ifAbsent: [ nil ]! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 10:42'!
initialize

	nextId := 0.
	processDict := Dictionary new.
	returnValuesDict := Dictionary new.
	exceptionsDict := Dictionary new.! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 12:17'!
nextId

	nextId := nextId + 1.
	^ nextId! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/8/2012 12:31'!
resume: aProcessId

	"resume previously suspended process, in case the other side responded before we suspended wait"

	[(processDict at: aProcessId) isSuspended] whileFalse: [
		Transcript show: 'Process activation mismatch'; cr.
		(Delay forMilliseconds: 10) wait.
	].
	
	(processDict at: aProcessId) resume.! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 10:48'!
resume: localProcessId withNewRemoteException: exceptionString

	exceptionsDict at: localProcessId put: exceptionString.
	self resume: localProcessId.! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/2/2014 10:48'!
resume: localProcessId withRemoteException: exceptionProxy

	exceptionsDict at: localProcessId put: exceptionProxy description. "forward only descriptions for the time being"
	self resume: localProcessId.! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/27/2012 15:58'!
resume: localProcessId withReturnValue: aValue

	self setReturnValueFor: localProcessId toValue: aValue. 
	self resume: localProcessId.! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/3/2012 21:05'!
returnValueFor: aProcessId
	|returnValue|
	returnValue := returnValuesDict removeKey: aProcessId.
	processDict removeKey: aProcessId.
	"returnValue xxx___isProxy ifTrue:[
		Transcript show: 'returning value (proxy): '; show: returnValue xxx___remoteObjectId; show: 'to processId: '; show: aProcessId; cr.
	]."
	^ returnValue! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 12:21'!
setReturnValueFor: aProcessId toValue: anObject

	returnValuesDict at: aProcessId put: anObject ! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2012 12:19'!
suspend: aProcessId

	(processDict at: aProcessId) suspend! !

!SeamlessProcessManager methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/26/2012 15:55'!
terminateAll

	processDict values do: [:process | process terminate.].
	self initialize.! !

Object subclass: #SeamlessSecurityPolicy
	instanceVariableNames: 'classesToPassByReference classesNotToReference classesSelectorDictInclude classesSelectorDictExclude'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Security-Policy'!

!SeamlessSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 14:04'!
newWithClassesToPassByReference: classesToPassByReferenceCollection classesNotToReference: classesNotToReferenceCollection includingMessages: classesSelectorIncludeDict excludingMessages: classesSelectorExcludeDict

	^ self new
		initializeWithClassesToPassByReference: classesToPassByReferenceCollection classesNotToReference: classesNotToReferenceCollection includingMessages: classesSelectorIncludeDict excludingMessages: classesSelectorExcludeDict! !

!SeamlessSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/25/2012 00:09'!
checkMessageToBeEvaluatedWithReceiver: anObject andSelector: aSelector

	classesSelectorDictInclude isEmpty ifTrue: [ "no restriction"
		
		(classesSelectorDictExclude keys includes: anObject class) ifTrue: [
			((classesSelectorDictExclude at: anObject class) includes: aSelector) ifTrue: [
				SeamlessSecurityError new signal: 'Restriction policy: should not send : ' , aSelector , ' to instances of class: ' , anObject class asString.	
			]
		]
		
	] ifFalse: [
		(classesSelectorDictInclude keys includes: anObject class) ifFalse: [
			SeamlessSecurityError new signal: 'Restriction policy: should not send : ' , aSelector , ' to instances of class: ' , anObject class asString.
		] ifTrue: [
			((classesSelectorDictInclude at: anObject class) includes: aSelector) ifFalse: [
				SeamlessSecurityError new signal: 'Restriction policy: should not send : ' , aSelector , ' to instances of class: ' , anObject class asString.	
			]
		]
	].! !

!SeamlessSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/25/2012 00:09'!
checkObjectToBeProxied: anObject

	classesToPassByReference isEmpty ifTrue: [ "no restriction"
			(classesNotToReference includes: anObject class) ifTrue: ["exclude rule"
				"refactor to an exception hierarchy"
				SeamlessSecurityError new signal: 'Restriction policy: should not proxify instances of class: ' , anObject class asString.
			]
	] ifFalse: [ "restricted set of classes to proxy"
			(classesToPassByReference includes: anObject class) ifFalse: [
				SeamlessSecurityError new signal: 'Restriction policy: should not proxify instances of class: ' , anObject class asString.
			]
	]! !

!SeamlessSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/2/2012 14:04'!
initializeWithClassesToPassByReference: classesToPassByReferenceCollection classesNotToReference: classesNotToReferenceCollection includingMessages: classesSelectorIncludeDict excludingMessages: classesSelectorExcludeDict

	classesToPassByReference := classesToPassByReferenceCollection.
	classesNotToReference := classesNotToReferenceCollection.
	classesSelectorDictInclude := classesSelectorIncludeDict.
	classesSelectorDictExclude := classesSelectorExcludeDict.! !

Object subclass: #SeamlessSession
	instanceVariableNames: 'sessionInfo deamon distributionStrategy authenticationManager processManager logging'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Session'!

!SeamlessSession class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/1/2012 15:46'!
newHandledBy: aDeamon onConnection: aSeamlessConnectionInfo withDistributionStrategy: aDistributionStrategy andAuthenticationManager: anAuthenticationManager

	^ self new 
		initializeWithDistributionStrategy: aDistributionStrategy andAuthenticationManager: anAuthenticationManager;
		deamon: aDeamon;
		onConnection: aSeamlessConnectionInfo.! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2012 14:31'!
connectionId

	^ sessionInfo connectionId ! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2012 15:11'!
deamon

	^ deamon! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2012 14:12'!
deamon: anObject

	deamon := anObject! !

!SeamlessSession methodsFor: 'seamless-protocol-entry-point' stamp: 'NickPapoulias 6/2/2012 22:21'!
entryPointRequestWithCredentials: seamlessUserCredentials withRemoteConnectionId: remoteConnectionId forRemoteProcess: remoteProcessId

	distributionStrategy distributionPolicy: (authenticationManager authenticate: seamlessUserCredentials). "can raise an error".
	
	sessionInfo remoteConnectionId: remoteConnectionId.
	
	self sendPackage: ((SeamlessEntryPointResponce new)
								remoteConnectionId: sessionInfo connectionId ;
								entryPoint: distributionStrategy entryPoint ;
								localProcessId: remoteProcessId).
! !

!SeamlessSession methodsFor: 'seamless-protocol-entry-point' stamp: 'NickPapoulias 8/24/2012 18:59'!
entryPointRequestWithCredentials: seamlessUserCredentials withRemoteConnectionId: remoteConnectionId forRemoteProcess: remoteProcessId inRemoteServer: aRemoteServerAddress

	distributionStrategy distributionPolicy: (authenticationManager authenticate: seamlessUserCredentials). "can raise an error".
	
	sessionInfo remoteConnectionId: remoteConnectionId.
	sessionInfo remoteServer: aRemoteServerAddress.
	
	self sendPackage: ((SeamlessEntryPointResponce new)
								remoteConnectionId: sessionInfo connectionId ;
								entryPoint: distributionStrategy entryPoint ;
								localProcessId: remoteProcessId;
								remoteServerAddress: sessionInfo localServer).
! !

!SeamlessSession methodsFor: 'seamless-protocol-entry-point' stamp: 'NickPapoulias 5/31/2012 10:13'!
entryPointResponceWithEntryPoint: entryPointWrapper withRemoteConnectionId: remoteConnectionId forLocalProcessId: localProcessId

	|entryPoint|

	entryPoint := entryPointWrapper resolveWith: distributionStrategy policy.
		
	sessionInfo remoteConnectionId: remoteConnectionId.
	
	processManager resume: localProcessId withReturnValue: entryPoint.! !

!SeamlessSession methodsFor: 'seamless-protocol-entry-point' stamp: 'NickPapoulias 8/24/2012 19:01'!
entryPointResponceWithEntryPoint: entryPointWrapper withRemoteConnectionId: remoteConnectionId forLocalProcessId: localProcessId fromRemoteServer: remoteServerAddress

	|entryPoint|

	entryPoint := entryPointWrapper resolveWith: distributionStrategy policy.
		
	sessionInfo remoteConnectionId: remoteConnectionId.
	sessionInfo remoteServer: remoteServerAddress.
	
	processManager resume: localProcessId withReturnValue: entryPoint.! !

!SeamlessSession methodsFor: 'seamless-protocol-message' stamp: 'NickPapoulias 6/1/2012 12:16'!
exceptionResponceWithMessage: exceptionString andOptionalRemoteException: exception forProcess: localProcessId

	|exceptionProxy|
	
	exception ifNotNil: [
		exceptionProxy := exception resolveWith: distributionStrategy policy.
		processManager resume: localProcessId withRemoteException: exceptionProxy.
	] ifNil: [
		processManager resume: localProcessId withNewRemoteException: exceptionString.
	]! !

!SeamlessSession methodsFor: 'seamless-protocol-gc' stamp: 'NickPapoulias 5/18/2012 14:38'!
garbageCollectionUpdateWithProxiedObjectsToUnrefence: proxiedObjectsToUnreference

	distributionStrategy garbageCollectUpdate: proxiedObjectsToUnreference.! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 8/21/2012 12:15'!
initializeWithDistributionStrategy: aDistributionStrategy andAuthenticationManager: anAuthenticationManager

	distributionStrategy := aDistributionStrategy.
	distributionStrategy session: self.
	authenticationManager := anAuthenticationManager.
	processManager :=  SeamlessProcessManager new.
	distributionStrategy processManager: processManager.
	logging := false.! !

!SeamlessSession methodsFor: 'logging' stamp: 'NickPapoulias 8/21/2012 14:20'!
log: receiver with: args and: selector

	logging ifTrue: [ 
		Transcript show: receiver class asString , '>>' , selector asString , '#( '. 
		args do: [:arg |
			arg xxx___isProxy ifTrue: [
				Transcript show: 'aProxy, '	
			] ifFalse: [
				Transcript show: args class asString , ', '.
			]
		].
		Transcript show: ' )'; cr.
	].! !

!SeamlessSession methodsFor: 'logging' stamp: 'NickPapoulias 8/21/2012 15:18'!
log: receiver with: args and: selector returning: returnValue

	logging ifTrue: [ 
		Transcript show: receiver class asString , '>>' , selector asString , '#( '. 
		args do: [:arg |
			arg xxx___isProxy ifTrue: [
				Transcript show: 'aProxy, '	
			] ifFalse: [
				Transcript show: arg asString , ', '.
			]
		].
		Transcript show: ' ) --> '.
		returnValue xxx___isProxy ifTrue: [
			Transcript show:  'aProxy'; cr.
		] ifFalse: [
			Transcript show: returnValue asString; cr.
		]
	].! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 8/21/2012 11:55'!
logging: aBoolean

	logging := aBoolean! !

!SeamlessSession methodsFor: 'seamless-protocol-message' stamp: 'NickPapoulias 11/2/2014 10:36'!
messageSendRequestWithReceiver: receiverWrapper selector: selector arguments: argumentWrappersAsArray forRemoteProcessId: remoteProcessId

	| receiver args returnValue |
	
	receiver := receiverWrapper resolveWith: distributionStrategy policy.
	args := argumentWrappersAsArray collect: [:wrapper | wrapper resolveWith: distributionStrategy policy].
	
	[distributionStrategy policy securityPolicy checkMessageToBeEvaluatedWithReceiver: receiver andSelector: selector] on: SeamlessSecurityError do: [: e |
				^ self sendPackage: ((SeamlessExceptionResponce new)
							initializeWithMessageText: e messageText exception: nil for: remoteProcessId).
	].
	"check if there is an exception -- and send it to the other side"
	
	
	SeamlessDeamonManager default exceptionForwarding ifTrue: [
	
		returnValue := [receiver perform: selector withArguments: args] on: Exception do: [:e | 
		
			self log: receiver with: args and: selector returning: e.
		
			self sendPackage: (SeamlessExceptionResponce 
				newForException: (distributionStrategy policy wrapperForObject: e);
				forProcessId: remoteProcessId).
				
			^ self		
		].
	] ifFalse: [
	
		returnValue := receiver perform: selector withArguments: args.
	
	]. 
	"check if there is an exception -- and send it to the other side"
	
	self log: receiver with: args and: selector returning: returnValue.
	
	self sendPackage: ((SeamlessReturnValueResponce new)
							returnValue: (distributionStrategy policy wrapperForObject: returnValue);
							remoteProcessId: remoteProcessId).! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:51'!
onConnection: aSeamlessConnectionInfo

	sessionInfo := SeamlessSessionInfo newWithConnectionInfo: aSeamlessConnectionInfo. 
	sessionInfo localServer: deamon serverAddress.! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 7/17/2012 16:22'!
policyCallback

	^ distributionStrategy policy ifNotNil: [ distributionStrategy policy policyCallback ] ! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 17:32'!
processManager 

	^ processManager ! !

!SeamlessSession methodsFor: 'seamless-protocol-package-handling' stamp: 'NickPapoulias 6/6/2012 17:54'!
receivedPackage: aPackage

	"double dispatch with packages"

	
	aPackage handleWith: self! !

!SeamlessSession methodsFor: 'seamless-protocol-message' stamp: 'NickPapoulias 6/3/2012 16:09'!
returnValueResponce: returnValue forProcess: processId
	
	|unwrappedReturnValue|
	
	unwrappedReturnValue := returnValue resolveWith: distributionStrategy policy.
	
	"Transcript show: 'Unwrapped: '; show: returnValue remoteObjectId.
	
	Transcript show: unwrappedReturnValue xxx___isProxy. "
	
	processManager resume: processId withReturnValue: unwrappedReturnValue. ! !

!SeamlessSession methodsFor: 'seamless-protocol-entry-point' stamp: 'NickPapoulias 8/24/2012 18:57'!
sendEntryPointRequestWithUsername: aUsername andPassword: aPassword

	|localProcessId|

	localProcessId := processManager add: (Processor activeProcess).
	
	"when we connect to other clients we are using the default user"
	distributionStrategy distributionPolicy: (authenticationManager authenticate: ((SeamlessUserCredentials new)
																						username: 'default';
																						password: '')).
	
	self sendPackage: ((SeamlessEntryPointRequest new)
							remoteConnectionId: self connectionId;
							seamlessUserCredentials: ((SeamlessUserCredentials new)
															username: aUsername;
															password: aPassword);
							remoteProcessId: localProcessId;
							localServerAddress: sessionInfo localServer).
	
	processManager suspend: localProcessId.
	"the process is suspended until the other end responds with the return value"
	^ processManager returnValueFor: localProcessId.! !

!SeamlessSession methodsFor: 'seamless-protocol-package-handling' stamp: 'NickPapoulias 6/10/2012 19:38'!
sendPackage: aPackage

	"this method is called after proxy creation / resolutions and security checks have occured"


	deamon sendPackage: aPackage through: self connectionId .! !

!SeamlessSession methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2012 12:25'!
sessionInfo

	^ sessionInfo ! !

Object subclass: #SeamlessSessionInfo
	instanceVariableNames: 'connectionInfo startTimeStamp localServer remoteServer remoteConnectionId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Session'!

!SeamlessSessionInfo class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/15/2012 12:44'!
newWithConnectionInfo: aSeamlessConnectionInfo 

	^ self new
		connectionInfo: aSeamlessConnectionInfo ! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 19:02'!
connectionId 
	^ connectionInfo id! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2012 12:26'!
connectionInfo
	^ connectionInfo! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2012 12:26'!
connectionInfo: anObject
	connectionInfo := anObject! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2012 14:22'!
initialize 

	startTimeStamp := DateAndTime current! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:49'!
localServer

	^ localServer! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:49'!
localServer: anAddress

	localServer := anAddress! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2012 14:32'!
remoteConnectionId
	^ remoteConnectionId! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2012 14:32'!
remoteConnectionId: anObject
	remoteConnectionId := anObject! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:49'!
remoteServer

	^ remoteServer! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 8/24/2012 18:48'!
remoteServer: anAddress

	remoteServer := anAddress! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2012 12:04'!
startTimeStamp
	^ startTimeStamp! !

!SeamlessSessionInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2012 12:04'!
startTimeStamp: anObject
	startTimeStamp := anObject! !

Object subclass: #SeamlessUser
	instanceVariableNames: 'name password group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Authentication-Manager'!

!SeamlessUser methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:14'!
group
	^ group! !

!SeamlessUser methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:14'!
group: anObject
	group := anObject! !

!SeamlessUser methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:15'!
password
	^ password! !

!SeamlessUser methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:15'!
password: anObject
	password := anObject! !

!SeamlessUser methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:14'!
username
	^ name! !

!SeamlessUser methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:14'!
username: anObject
	name := anObject! !

Object subclass: #SeamlessUserCredentials
	instanceVariableNames: 'name password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Authentication-Manager'!

!SeamlessUserCredentials methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:01'!
password
	^ password! !

!SeamlessUserCredentials methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:01'!
password: anObject
	password := anObject! !

!SeamlessUserCredentials methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:01'!
username
	^ name! !

!SeamlessUserCredentials methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:01'!
username: anObject
	name := anObject! !

Object subclass: #SeamlessUserGroup
	instanceVariableNames: 'distributionPolicy groupName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Authentication-Manager'!

!SeamlessUserGroup methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:00'!
distributionPolicy
	^ distributionPolicy! !

!SeamlessUserGroup methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:00'!
distributionPolicy: anObject
	distributionPolicy := anObject! !

!SeamlessUserGroup methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:00'!
groupName
	^ groupName! !

!SeamlessUserGroup methodsFor: 'accessing' stamp: 'NickPapoulias 6/2/2012 16:00'!
groupName: anObject
	groupName := anObject! !
SeamlessFastDNUProxy initialize!
AbstractSeamlessConnection initialize!
SeamlessSocketStreamConnection initialize!
SeamlessSocketStreamTransporterTest initialize!
SeamlessDeamonManager initialize!
SeamlessSocketStreamTransporter initialize!
